#ifndef PRNG_H
#define PRNG_H

#define IDLING 400;
#define KEY_LENGTH 4
#define SEED_MASK 0xF423FL
#define SMALL_BUFFER_SIZE 64
#define TEN_DIGITS 1000000000
//                 1234567890
#include <string>
#include <time.h>
#include "mt19937ar.h"

void setMT(long seed, int from);

class PRNG {
protected:

public:
    virtual ~PRNG(){}

    virtual unsigned int nextRandom() = 0;
};

class MT : public PRNG {
    long seeding;

public:
    ~MT(){}

    unsigned int nextRandom() {
        unsigned long y = genrand_int32();
        unsigned int n = (unsigned int)y;
        return n;
    }

    MT(long s);
    MT(long s, int from);
};

class Xorshift : public PRNG {
    long seeding;
    unsigned long x, y, z, w;

public:
    ~Xorshift(){}

    unsigned int nextRandom();
    void setting();
    Xorshift(long s);
};

#endif // PRNG_H
