/*
In 2003, xorshift was discovered by George Marsaglia.
good C random number generator
Date: 2003-05-13 08:55:05 PST
http://school.anhb.uwa.edu.au/personalpages/kwessen/shared/Marsaglia03.html

xorshift.pdf
http://www.jstatsoft.org/v08/i14/paper
- quote -
the xorshift:
unsigned long xor128(){
static unsigned long x=123456789,y=362436069,z=521288629,w=88675123;
unsigned long t;
t=(x^(x<<11));x=y;y=z;z=w; return( w=(w^(w>>19))^(t^(t>>8)) );
}
- unquote -

*/

#include "PRNG.h"

Xorshift::Xorshift(long s) {
    long e;
    seeding = s;

// Setting before idling
    x = 123456789;
    y = 362436069;
    z = 521288629;
    w = 88675123;

    if(seeding == 0) {
        e = (long)time(NULL);
        seeding = e & SEED_MASK;
    }

// idling before setPRNG()
    for(int k = 0; k < seeding; ++k) { 
        nextRandom();
    }

}

unsigned int Xorshift::nextRandom() {
    unsigned long t;
    t = x ^ (x << 11);
    x = y;
    y = z;
    z = w;
    w = ( w ^ (w >> 19) ) ^ (t ^ (t >> 8) );
    unsigned int n = (unsigned int)w;
    return n;
}
