#include "heightWidth.h"

extern FocusPane *focusPane;
extern Kopic *kopic;

void save_cb(Fl_Widget *, void *) {
    focusPane->saveHandler();
}

void close_focus_cb(Fl_Widget *, void *) {
    focusPane->hide();
}

void FocusPane::centering() {
    SITE_SIZE ss = measuringScreenSize(FOCUS_WIDTH, FOCUS_HEIGHT);
    focusPane->resize(ss.x, ss.y, ss.w, ss.h);
}

void FocusPane::saveHandler() {
    using namespace std;

    char *stop;
    focus_left = (int)strtol( input1->value(), &stop, 10);
    if(focus_left < 0) {
        focus_left = 0;
    } else if(focus_left >= data_width) {
        focus_left = data_width - 1;
    }

    focus_top = (int)strtol( input2->value(), &stop, 10);
    if(focus_top < 0) {
        focus_top = 0;
    } else if(focus_top >= data_height) {
        focus_top = data_height - 1;
    }

    focus_right = (int)strtol( input3->value(), &stop, 10);
    if(focus_right < 1) {
        focus_right = 1;
    } else if(focus_right > data_width) {
        focus_right = data_width;
    }

    focus_bottom = (int)strtol( input4->value(), &stop, 10);
    if(focus_bottom < 1) {
        focus_bottom = 1;
    } else if(focus_bottom > data_height) {
        focus_bottom = data_height;
    }

// Checking if the focus rectangle has enough width.
    if( focus_right - focus_left < 1 ) {
        focus_left = 0;
        focus_right = data_width;
    }

// Checking if the focus rectangle has enough height.
    if( focus_bottom - focus_top < 1 ) {
        focus_top = 0;
        focus_bottom = data_height;
    }

    stringstream os;
    os << focus_left << COMMA << focus_top << SEPARATOR << focus_right << COMMA << focus_bottom;
    string s = os.str();
    kopic->focussing(s, focus_left, focus_top, focus_right, focus_bottom);
}

bool FocusPane::setting(KUN_CODE *p) {
    using namespace std;

    const int BORDER = 3;
    const int BORDER_AREA = 73;

    data_height = p->data_height;
    data_width = p->data_width;
    focus_left = 0;
    focus_top = 0;
    focus_right = data_width;
    focus_bottom = data_height;

    int y = 0;
    closeButton = new Fl_Button(BUTTON_X, y, CLOSE_BUTTON_WIDTH, CLOSE_BUTTON_HEIGHT, "Close");
    closeButton->callback( (Fl_Callback *)close_focus_cb, this);

    y += CLOSE_BUTTON_HEIGHT + BORDER;
    input1 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "Left");
    input1->value("0");
    input1->box(FL_BORDER_BOX);
    input1->callback( (Fl_Callback *)save_cb, this);
    input1->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input2 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "Top");
    input2->value("0");
    input2->box(FL_BORDER_BOX);
    input2->callback( (Fl_Callback *)save_cb, this);
    input2->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input3 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "Right");
    input3->value("40");
    input3->box(FL_BORDER_BOX);
    input3->callback( (Fl_Callback *)save_cb, this);
    input3->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input4 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "Bottom");
    input4->value("40");
    input4->box(FL_BORDER_BOX);
    input4->callback( (Fl_Callback *)save_cb, this);
    input4->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    saveButton = new Fl_Button(BUTTON_X, y, SAVE_BUTTON_WIDTH, SAVE_BUTTON_HEIGHT, "Save");
    saveButton->callback( (Fl_Callback *)save_cb, this);
    saveButton->take_focus();
    return true;
}

