/*
Kopic FLTK Version 1.16
Producing Loto-7 combinations
Copyright 2017 Sogaya

GCC
FLTK 1.3.0

*/

#include "heightWidth.h"

char buffer[ MAIN_BUFFER_SIZE + 1 ];
char NO_BLOCK[KOPIC_KUN_SIZE];
extern bool EX_OR_array[XBM_HEIGHT][XBM_WIDTH];
extern bool xbm_boolean_array[XBM_HEIGHT][XBM_WIDTH];
extern char h[256][3];
FocusPane *focusPane;
int TITLE_BAR_HEIGHT = 19;
KUN_CODE *kunCode;
long untouched;
MANAGE_MEMO manage_memo; // rannuText.h
MANAGE_MEMO *mm = &manage_memo;
Fl_Boxtype boxList[BOX_LIST_SIZE] = {
    FL_DIAMOND_UP_BOX, 
    FL_PLASTIC_UP_BOX, 
    _FL_DIAMOND_DOWN_BOX, 
    _FL_DIAMOND_UP_BOX, 
    _FL_GTK_DOWN_BOX, 
    _FL_GTK_DOWN_FRAME, 
    _FL_GTK_ROUND_DOWN_BOX, 
    _FL_GTK_ROUND_UP_BOX, 
    _FL_GTK_THIN_DOWN_FRAME, 
    _FL_GTK_THIN_UP_BOX, 
    _FL_GTK_THIN_UP_FRAME, 
    _FL_GTK_UP_BOX, 
    _FL_GTK_UP_FRAME, 
    _FL_OFLAT_BOX, 
    _FL_OSHADOW_BOX, 
    _FL_OVAL_BOX, 
    _FL_OVAL_FRAME, 
    _FL_PLASTIC_DOWN_BOX, 
    _FL_PLASTIC_DOWN_FRAME, 
    _FL_PLASTIC_ROUND_DOWN_BOX, 
    _FL_PLASTIC_ROUND_UP_BOX, 
    _FL_PLASTIC_THIN_DOWN_BOX, 
    _FL_PLASTIC_THIN_UP_BOX, 
    _FL_PLASTIC_UP_BOX, 
    _FL_PLASTIC_UP_FRAME, 
    _FL_RFLAT_BOX, 
    _FL_ROUND_DOWN_BOX, 
    _FL_ROUND_UP_BOX, 
    _FL_ROUNDED_BOX, 
    _FL_ROUNDED_FRAME, 
    _FL_RSHADOW_BOX, 
    _FL_SHADOW_BOX, 
    _FL_SHADOW_FRAME, 
    FL_BORDER_BOX, 
    FL_BORDER_FRAME, 
    FL_CIRCLE_BOX, 
    FL_DIAMOND_BOX, 
    FL_DIAMOND_DOWN_BOX, 
    FL_DOWN_BOX, 
    FL_DOWN_FRAME, 
    FL_EMBOSSED_BOX, 
    FL_EMBOSSED_FRAME, 
    FL_ENGRAVED_BOX, 
    FL_ENGRAVED_FRAME, 
    FL_FLAT_BOX, 
    FL_FRAME, 
    FL_FRAME_BOX, 
    FL_FREE_BOXTYPE, 
    FL_GTK_DOWN_BOX, 
    FL_GTK_DOWN_FRAME, 
    FL_GTK_ROUND_DOWN_BOX, 
    FL_GTK_ROUND_UP_BOX, 
    FL_GTK_THIN_DOWN_BOX, 
    FL_GTK_THIN_DOWN_FRAME, 
    FL_GTK_THIN_UP_BOX, 
    FL_GTK_THIN_UP_FRAME, 
    FL_GTK_UP_BOX, 
    FL_GTK_UP_FRAME, 
    FL_OFLAT_BOX, 
    FL_OSHADOW_BOX, 
    FL_OVAL_BOX, 
    FL_OVAL_FRAME, 
    FL_PLASTIC_DOWN_BOX, 
    FL_PLASTIC_DOWN_FRAME, 
    FL_PLASTIC_ROUND_DOWN_BOX, 
    FL_PLASTIC_ROUND_UP_BOX, 
    FL_PLASTIC_THIN_DOWN_BOX, 
    FL_PLASTIC_THIN_UP_BOX, 
    FL_PLASTIC_UP_FRAME, 
    FL_RFLAT_BOX, 
    FL_ROUND_DOWN_BOX, 
    FL_ROUND_UP_BOX, 
    FL_ROUNDED_BOX, 
    FL_ROUNDED_FRAME, 
    FL_RSHADOW_BOX, 
    FL_SHADOW_BOX, 
    FL_SHADOW_FRAME, 
    FL_THIN_DOWN_BOX, 
    FL_THIN_DOWN_FRAME, 
    FL_THIN_UP_BOX, 
    FL_THIN_UP_FRAME, 
    FL_UP_BOX, 
    FL_UP_FRAME
};

Kopic *kopic;
MessagePane *messagePane;
VersionPane *versionPane;
WeightPane *weightPane;

bool kopicCsvTouched() {
    using namespace std;

// Checking if KOPIC_CSV exists
    ifstream csv(KOPIC_CSV);
    if( csv.fail() ) {
        return true;
    } else {
        csv.close();
    }

// Checking if KOPIC_CSV has been modified
    bool b = true;
    long m = modified_file(KOPIC_CSV);
    if(m == untouched) {
        b = false;
    } else {
        untouched = m;
    }

    return b;
}

bool Kopic::kunExpand() {
    using namespace std;     

    bool expanded[ XBM_HEIGHT * XBM_WIDTH ];
    const int XBM_HEIGHT_1 = XBM_HEIGHT + 1;
    const string NEW_LINE("\n");
    int black_or_white, count, DEL_count, n, q, sum, u;
    int estimated_width[ XBM_HEIGHT + 1 ];

    DEL_count = 0;
    n = 0;
    q = 0;
    sum = 0;
    for(int k = SIGNATURE; k < ks.kun_size && DEL_count < XBM_HEIGHT_1; k++, q++) {
        if(unexpanded[k] == DEL) {
            estimated_width[DEL_count] = sum;
            DEL_count += 1;
            q = 0;
            sum = 0;
            continue;
        }

        count = (int)unexpanded[k];
        sum += count;
        black_or_white = q%2;
        switch(black_or_white) {
        case BLACK:
            for(u = 0; u < count; u++) {
                expanded[n++] = true;
            }

            break;
        case WHITE:
            for(u = 0; u < count; u++) {
                expanded[n++] = false;
            }

            break;
        }

    }

// Checking if width is constant.
    data_height = DEL_count - 1;
    for(int m = 2; m < data_height; m++) {
        if(estimated_width[m] == estimated_width[1]) {
            continue;
        } else {
            ofstream file(ERROR_TEXT);
            file << "estimated_width[1] = " << estimated_width[1] << endl 
                << "estimated_width[" << m << "] = " << estimated_width[m] << endl;
            return false;
        }

    }

    data_width = estimated_width[1];
    n = 0;
    for(int m = 0; m < data_height; m++) {
        for(q = 0; q < data_width; q++, n++) {
            EX_OR_array[m][q] = xbm_boolean_array[m][q] ^ expanded[n];
            xbm_boolean_array[m][q] = expanded[n];
        }

    }

    return true;
}

bool Kopic::openDoubleRecordUndo() {
    using namespace std;

    const bool SERIAL_NUMBER = true;
    const TimeName undo1_bin(UND, BINARY_FILE);
    const TimeName undo2_bin(UND, BINARY_FILE);
    TimeName ub[2] = {undo1_bin, undo2_bin};

    for(int i = 0; i < 2; ++i) {
        timeNameText[i] = ub[i].temporaryName(SERIAL_NUMBER);

        if(! doubleRecordUndoClosed[i]) {
            putDoubleRecordUndo[i].close();
        }

        putDoubleRecordUndo[i].open( timeNameText[i].c_str(), ios::out | ios::binary );
        if( putDoubleRecordUndo[i].fail() ) {
            return false;
        }

        doubleRecordUndoClosed[i] = false;
        recordNumber[i] = 1;
    }

    return true;
}

bool Kopic::readUndoBin() {
    using namespace std;     
     
    if(recordNumber[0] == 1) {
        return false;
    }

    if(! doubleRecordUndoClosed[0]) {
        putDoubleRecordUndo[0].close();
        doubleRecordUndoClosed[0] = true;
    }

    getDoubleRecordUndo[0].open( timeNameText[0].c_str(), ios::in | ios::binary );
    if( getDoubleRecordUndo[0].fail() ) {
        return false;
    }

    recordNumber[0] -= 1;
    streampos begin = RECORD_SIZE * ( recordNumber[0] - 1 );
    getDoubleRecordUndo[0].seekg(begin);
    getDoubleRecordUndo[0].read(record, RECORD_SIZE);
    getDoubleRecordUndo[0].close();

    int reverse_command = record[0];
    cell_x = record[1];
    cell_y = record[2];
    ud.previous_aim = record[3];
    ud.previous_item = record[4];
    ud.previous_x = record[5];
    ud.previous_y = record[6];
    ud.previous_block_x = record[7];
    ud.previous_block_y = record[8];

// little-endian architecture
    ks.size_bytes[0] = record[9];
    ks.size_bytes[1] = record[10];
    ks.size_bytes[2] = record[11];
    ks.size_bytes[3] = record[12];
    r.number_bytes[0] = record[ PARAMETER_COUNT - 4 ];
    r.number_bytes[1] = record[ PARAMETER_COUNT - 3 ];
    r.number_bytes[2] = record[ PARAMETER_COUNT - 2 ];
    r.number_bytes[3] = record[ PARAMETER_COUNT - 1 ];

    char *non_parameter = & record[PARAMETER_COUNT];
    if(ks.kun_size <= RECORD_SIZE - PARAMETER_COUNT) {
        memcpy(ud.unexpanded, non_parameter, KOPIC_KUN_SIZE);
    } else {
        if(! doubleRecordUndoClosed[1]) {
            putDoubleRecordUndo[1].close();
            doubleRecordUndoClosed[1] = true;
        }

        getDoubleRecordUndo[1].open( timeNameText[1].c_str(), ios::in | ios::binary );
        if( getDoubleRecordUndo[1].fail() ) {
            return false;
        }

        recordNumber[1] -= 1;
        streampos begin = FULL_RECORD_SIZE * ( recordNumber[1] - 1 );
        getDoubleRecordUndo[1].seekg(begin);
        getDoubleRecordUndo[1].read(full_record, FULL_RECORD_SIZE);
        getDoubleRecordUndo[1].close();

        non_parameter = & full_record[PARAMETER_COUNT];
        memcpy(ud.unexpanded, non_parameter, KOPIC_KUN_SIZE);
    }

    clearCursor();
    setStatusBar();
    placeCursor();

    switch(reverse_command) {
    case UNDO_CLEAR:
        undoClear();
        break;
    case UNDO_DRAW:
        undoDraw();
        break;
    case UNDO_END:
        undoEnd();
        break;
    case UNDO_FILL:
        undoFill();
        break;
    case UNDO_GO:
        undoGo();
        break;
    case UNDO_LINE:
        undoLine();
        break;
    case UNDO_START:
        undoStart();
        break;
    }

    return true;
}

bool Kopic::setting(KUN_CODE *p, VersionPane *v) {
    using namespace std;

    int sub_height, sub_width, sub_x, sub_y;

    cell_height = p->cell_height;
    cell_width = p->cell_width;
    data_height = p->data_height;
    data_width = p->data_width;
    decrement_by_n = p->decrement_by_n;
    diamond = p->diamond;
    versionPane = v;

    if(diamond < 0) {
        diamond_square = boxList[DIAMOND];
    } else if(BOX_LIST_SIZE <= diamond) { 
        diamond_square = boxList[DIAMOND];
    } else { 
        diamond_square = boxList[diamond];
    }

// Alt  +  BCDEFGHI KLMNOP RSTUVWX  
// Ctrl +  B DEFGHIJKLMNOPQRSTUVWXYZ
    Fl_Menu_Item menuitems[] = {
    { "&File", 0, 0, 0, FL_SUBMENU },
    { "CSV       ", 0, (Fl_Callback *)csv_cb, 0, },
    { "Decrement ", 0, (Fl_Callback *)decrement_cb, 0, },
    { "&KUN      ", 0, (Fl_Callback *)kun_cb, 0, },
    { "Text      ", 0, (Fl_Callback *)text_cb, 0, },
    { "Undo      ", FL_COMMAND + 't', (Fl_Callback *)undo_cb, 0, },
    { "&XBM      ", 0, (Fl_Callback *)xbm_cb, 0, FL_MENU_DIVIDER },
    { "Exit      ", FL_COMMAND + 'q', (Fl_Callback *)quit_cb, 0 },
    { "Expand    ", 0, (Fl_Callback *)expand_cb, 0, },
    { "Full-swing", 0, (Fl_Callback *)full_swing_cb, 0, },
    { 0 },
    { "&Go", 0, 0, 0, FL_SUBMENU },
    { "Corner    ", 0, (Fl_Callback *)go_corner_cb, 0, },
    { "Diagonal  ", 0, (Fl_Callback *)go_diagonal_cb, 0, },
    { "End       ", 0, (Fl_Callback *)go_end_cb, 0, },
    { "Jump      ", FL_COMMAND + 'z', (Fl_Callback *)go_jump_cb, 0, FL_MENU_DIVIDER },
    { "Up        ", FL_COMMAND + 'e', (Fl_Callback *)go_up_cb, 0 },
    { "->        ", FL_COMMAND + 'd', (Fl_Callback *)go_right_cb, 0 },
    { "<-        ", FL_COMMAND + 's', (Fl_Callback *)go_left_cb, 0 },
    { "Down      ", FL_COMMAND + 'x', (Fl_Callback *)go_down_cb, 0 },
    { 0 },
    { "&Draw", 0, 0, 0, FL_SUBMENU },
    { "End       ", FL_COMMAND + 'r', (Fl_Callback *)draw_end_cb, 0, },
    { "Start     ", FL_COMMAND + 'y', (Fl_Callback *)draw_start_cb, 0, FL_MENU_DIVIDER },
    { "Inver&t   ", 0, (Fl_Callback *)draw_invert_cb, 0, FL_MENU_DIVIDER },
    { "Up        ", FL_COMMAND + 'u', (Fl_Callback *)draw_up_cb, 0 },
    { "->        ", FL_COMMAND + 'j', (Fl_Callback *)draw_right_cb, 0 },
    { "<-        ", FL_COMMAND + 'h', (Fl_Callback *)draw_left_cb, 0 },
    { "Down      ", FL_COMMAND + 'n', (Fl_Callback *)draw_down_cb, 0 },
    { 0 },
    { "Li&ne", 0, 0, 0, FL_SUBMENU },
    { "End       ", FL_COMMAND + 'f', (Fl_Callback *)line_end_cb, 0, },
    { "Start     ", FL_COMMAND + 'p', (Fl_Callback *)line_start_cb, 0, FL_MENU_DIVIDER },
    { "To        ", FL_COMMAND + 'i', (Fl_Callback *)line_to_cb, 0, FL_MENU_DIVIDER },
    { "&Right    ", 0, (Fl_Callback *)line_right_cb, 0 },
    { "&Under    ", 0, (Fl_Callback *)line_under_cb, 0 },
    { 0 },
    { "&Clear", 0, 0, 0, FL_SUBMENU },
    { "End       ", FL_COMMAND + 'w', (Fl_Callback *)clear_end_cb, 0, },
    { "Start     ", FL_COMMAND + 'b', (Fl_Callback *)clear_start_cb, 0, FL_MENU_DIVIDER },
    { "->        ", FL_COMMAND + 'g', (Fl_Callback *)clear_right_cb, 0 },
    { "Down      ", FL_COMMAND + 'v', (Fl_Callback *)clear_down_cb, 0, FL_MENU_DIVIDER },
    { "S&ide     ", 0, (Fl_Callback *)clear_side_cb, 0 },
    { "&Bottom   ", 0, (Fl_Callback *)clear_bottom_cb, 0 },
    { 0 },
    { "Fi&ll", 0, 0, 0, FL_SUBMENU },
    { "End       ", FL_COMMAND + 'm', (Fl_Callback *)fill_end_cb, 0, },
    { "Start     ", FL_COMMAND + 'l', (Fl_Callback *)fill_start_cb, 0, FL_MENU_DIVIDER },
    { "->        ", FL_COMMAND + 'o', (Fl_Callback *)fill_right_cb, 0 },
    { "Down      ", FL_COMMAND + 'k', (Fl_Callback *)fill_down_cb, 0, FL_MENU_DIVIDER },
    { "Sid&e     ", 0, (Fl_Callback *)fill_side_cb, 0 },
    { "Botto&m   ", 0, (Fl_Callback *)fill_bottom_cb, 0 },
    { 0 },
    { "&Setting ", 0, 0, 0, FL_SUBMENU },
    { "F&ocus    ", 0, (Fl_Callback *)focus_cb, 0 },
    { "&Weight   ", 0, (Fl_Callback *)weight_cb, 0 },
    { 0 },
    { "&Help", 0, 0, 0, FL_SUBMENU },
    { "&PDF      ", 0, (Fl_Callback *)pdf_cb, 0 },
    { "&Version  ", 0, (Fl_Callback *)version_cb, 0 },
    { 0 },
    { 0 }
    };

    sub_height = MENU_BAR_HEIGHT;
    sub_width = main_width;
    sub_x = 0;
    sub_y = 0;
    menu = new Fl_Menu_Bar(sub_x, sub_y, sub_width, sub_height);
    menu->box(FL_FLAT_BOX);
    menu->copy(menuitems);

    sub_height = STATUS_BAR_HEIGHT + STATUS_BAR_LABEL_HEIGHT - 2*MARGIN;
    sub_width = main_width;
    sub_x = 0;
    sub_y = main_height - STATUS_BAR_HEIGHT - STATUS_BAR_LABEL_HEIGHT + MARGIN;
    textBuffer = new Fl_Text_Buffer();
    statusBar = new Fl_Text_Display(sub_x, sub_y, sub_width, sub_height, " ");
    statusBar->buffer(textBuffer);
    statusBar->textsize(22);
    statusBar->box(FL_FLAT_BOX);
    stringstream os;
    os << "0,0";
    string s = os.str();
    textBuffer->text( s.c_str() );

    for(int i = 0; i < XBM_HEIGHT; ++i) {
        for(int k = 0; k < XBM_WIDTH; ++k) {
            square[i][k] = new Fl_Button( k * cell_width, i * cell_height + MENU_BAR_HEIGHT, cell_width, cell_height, "");
            square[i][k]->callback( (Fl_Callback *)button_cb );
            square[i][k]->color(FL_BACKGROUND_COLOR);
            square[i][k]->box(FL_FLAT_BOX);
        }

    }

    cell_x = 0;
    cell_y = 0;
    return true;
}

bool Kopic::undoThat() {
    bool b = true;

    if(recordNumber[0] == 1) {
        return b;
    }

    if(first_undo) {
        firstUndo();
        if(! readUndoBin() ) {
            b = false;
        }

        first_undo = false;
    }

    if(! readUndoBin() ) {
        b = false;
    }

    return b;
}

int main (int argc, char *argv[]) {
    bool drawXbm = false;
    const int ARGC = 1;
    char *ARGV[2] = {"kopic.exe", NULL};
    PICK_CODE pc;
    KUN_CODE kc = readXbm(argc, argv);
    if(kc.cell_height < 2) {
        kc.cell_height = 2;
    }

    if(kc.cell_width < 2) {
        kc.cell_width = 2;
    }

    int area_height = kc.cell_height * XBM_HEIGHT;
    int area_width = kc.cell_width * XBM_WIDTH;

    Fl::set_font(FL_HELVETICA, "Kochi Gothic");

    switch(kc.code) {
    case CSV_SPECIFIED:
        pc = kopicLog(kc.file_name, &kc);
        messagePane = new MessagePane(MESSAGE_WIDTH, MESSAGE_HEIGHT, "Message");
        messagePane->setting(&pc);
        messagePane->end();
        messagePane->centering();
        messagePane->resizable(NULL);
        messagePane->set_modal();
        messagePane->show();
        return Fl::run();
    case XBM_READ:
        if(kc.full_swing) {
            read_rewrite_if_necessary(KOPIC_CSV, &kc);
            drawXbm = false;
        } else {
            drawXbm = true;
        }

        break;
    default:
        break;
    }

    if(kc.newXbm) {
        kc = readXbm(ARGC, ARGV);
        if(kc.cell_height < 2) {
            kc.cell_height = 2;
        }

        if(kc.cell_width < 2) {
            kc.cell_width = 2;
        }

        area_height = kc.cell_height * XBM_HEIGHT;
        area_width = kc.cell_width * XBM_WIDTH;

        switch(kc.code) {
        case XBM_READ:
            kopicLog(KOPIC_CSV, &kc);
            break;
        }

    } else {
        if(! drawXbm) {
            return 0;
        }

    }

    focusPane = new FocusPane(FOCUS_WIDTH, FOCUS_HEIGHT, "Focus");
    focusPane->setting(&kc);
    focusPane->end();
    focusPane->centering();
    focusPane->resizable(NULL);
    focusPane->set_modal();
    focusPane->hide();

    versionPane = new VersionPane(VERSION_WIDTH, VERSION_HEIGHT, "Version");
    versionPane->setting();
    versionPane->end();
    versionPane->centering();
    versionPane->resizable(NULL);
    versionPane->set_modal();
    versionPane->hide();

    weightPane = new WeightPane(WEIGHT_WIDTH, WEIGHT_HEIGHT, "Weight");
    kunCode = &kc;
    pc = weightPane->setting(KOPIC_CSV, kunCode);
    if(pc.code != UNPICKED) {
        return 0;
    }

    weightPane->end();
    const int BORDER = weightPane->centering();
    weightPane->resizable(NULL);
    weightPane->set_modal();
    weightPane->hide();

    int main_height = area_height + TITLE_BAR_HEIGHT + STATUS_BAR_HEIGHT + STATUS_BAR_LABEL_HEIGHT + 2 * BORDER;
    int main_width = area_width;

    kopic = new Kopic(main_width, main_height, "Kopic");
    kopic->setting(&kc, versionPane);
    kopic->end();
    kopic->resize(MAIN_X, MAIN_Y, main_width, main_height);
    kopic->resizable(NULL);
    kopic->goStart();
    kopic->standardHandler();

    create_kopic_icon(kopic);
    kopic->show();

    Fl::add_timeout(NONSAMPLING_PERIOD, timer_cb);
    return Fl::run();
}

long modified_file(const char *s) {
    long g;
    struct stat file_time;
    struct tm *p;

    if(! stat(s, &file_time) ) {
        p = gmtime( &(file_time.st_mtime) );
        g = p->tm_sec + 60*p->tm_min + 60*60*p->tm_hour + 60*60*24*p->tm_yday;
    } else {
        g = 0L;
    }

    return g;
}

PICK_CODE read_rewrite_if_necessary(const char *file_name, KUN_CODE *p) {
    PICK_CODE pc;

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    pc.code = UNPICKED;
    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
        pc.code = FULL_SWING_TEXT;
    }

    return pc;
}

void button_cb(Fl_Widget *, void *) {
    kopic->CmGoJump();
}

void clear_bottom_cb(Fl_Widget *, void *) {
    kopic->CmClearBottom();
}

void clear_down_cb(Fl_Widget *, void *) {
    kopic->CmClearDown();
}

void clear_end_cb(Fl_Widget *, void *) {
    kopic->CmClearEnd();
}

void clear_right_cb(Fl_Widget *, void *) {
    kopic->CmClearRight();
}

void clear_side_cb(Fl_Widget *, void *) {
    kopic->CmClearSide();
}

void clear_start_cb(Fl_Widget *, void *) {
    kopic->CmClearStart();
}

void csv_cb(Fl_Widget *, void *) {
    kopic->CmCsv();
}

void decrement_cb(Fl_Widget *, void *) {
    kopic->CmDecrement();
}

void draw_down_cb(Fl_Widget *, void *) {
    kopic->CmDrawDown();
}

void draw_end_cb(Fl_Widget *, void *) {
    kopic->CmDrawEnd();
}

void draw_invert_cb(Fl_Widget *, void *) {
    kopic->CmDrawInvert();
}

void draw_left_cb(Fl_Widget *, void *) {
    kopic->CmDrawLeft();
}

void draw_right_cb(Fl_Widget *, void *) {
    kopic->CmDrawRight();
}

void draw_start_cb(Fl_Widget *, void *) {
    kopic->CmDrawStart();
}

void draw_up_cb(Fl_Widget *, void *) {
    kopic->CmDrawUp();
}

void expand_cb(Fl_Widget *, void *) {
    if( kunExpand(KOPIC_KUN) ) {
        destroy_kopic_icon();
        exit(0);
    }

}

void fill_bottom_cb(Fl_Widget *, void *) {
    kopic->CmFillBottom();
}

void fill_down_cb(Fl_Widget *, void *) {
    kopic->CmFillDown();
}

void fill_end_cb(Fl_Widget *, void *) {
    kopic->CmFillEnd();
}

void fill_right_cb(Fl_Widget *, void *) {
    kopic->CmFillRight();
}

void fill_side_cb(Fl_Widget *, void *) {
    kopic->CmFillSide();
}

void fill_start_cb(Fl_Widget *, void *) {
    kopic->CmFillStart();
}

void focus_cb(Fl_Widget *, void *) {
    kopic->CmFocus();
}

void full_swing_cb(Fl_Widget *, void *) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
    fullSwing(KOPIC_CSV);

    destroy_kopic_icon();
    exit(0);
}

void go_corner_cb(Fl_Widget *, void *) {
    kopic->CmGoCorner();
}

void go_diagonal_cb(Fl_Widget *, void *) {
    kopic->CmGoDiagonal();
}

void go_down_cb(Fl_Widget *, void *) {
    kopic->CmGoDown();
}

void go_end_cb(Fl_Widget *, void *) {
    kopic->clearCursor();
}

void go_jump_cb(Fl_Widget *, void *) {
    kopic->CmGoJump();
}

void go_left_cb(Fl_Widget *, void *) {
    kopic->CmGoLeft();
}

void go_right_cb(Fl_Widget *, void *) {
    kopic->CmGoRight();
}

void go_up_cb(Fl_Widget *, void *) {
    kopic->CmGoUp();
}

void help_cb(Fl_Widget *, void *) {
    versionPane->helpHandler();
}

void Kopic::addUndoData() {
    record[0] = (char)ud.reverse_command;
    record[1] = (char)ud.cell_x;
    record[2] = (char)ud.cell_y;
    record[3] = (char)ud.previous_aim;
    record[4] = (char)ud.previous_item;
    record[5] = (char)ud.previous_x;
    record[6] = (char)ud.previous_y;
    record[7] = (char)ud.previous_block_x;
    record[8] = (char)ud.previous_block_y;
    record[9] = ks.size_bytes[0];
    record[10] = ks.size_bytes[1];
    record[11] = ks.size_bytes[2];
    record[12] = ks.size_bytes[3];

    if( doubleRecordUndoClosed[0] | doubleRecordUndoClosed[1] ) {
        openDoubleRecordUndo();
    }

    char *p = & record[PARAMETER_COUNT];
    if(ud.unexpanded != & NO_BLOCK[0]) {
        memcpy(p, ud.unexpanded, RECORD_SIZE - PARAMETER_COUNT);
    }

    std::streampos begin = RECORD_SIZE * ( recordNumber[0] - 1 );
    putDoubleRecordUndo[0].seekp(begin);
    putDoubleRecordUndo[0].write(record, RECORD_SIZE);

    first_undo = true;

// Setting the next record number
    recordNumber[0] += 1;

    if(ks.kun_size <= RECORD_SIZE - PARAMETER_COUNT) {
        r.record_number = recordNumber[0];
        record[ PARAMETER_COUNT - 4 ] = r.number_bytes[0];
        record[ PARAMETER_COUNT - 3 ] = r.number_bytes[1];
        record[ PARAMETER_COUNT - 2 ] = r.number_bytes[2];
        record[ PARAMETER_COUNT - 1 ] = r.number_bytes[3];
    } else {
        r.record_number = recordNumber[1];
        record[ PARAMETER_COUNT - 4 ] = r.number_bytes[0];
        record[ PARAMETER_COUNT - 3 ] = r.number_bytes[1];
        record[ PARAMETER_COUNT - 2 ] = r.number_bytes[2];
        record[ PARAMETER_COUNT - 1 ] = r.number_bytes[3];

// full_record is larger than record so that full_record can preserve the integrity.
        memset(full_record, 0, FULL_RECORD_SIZE);
        for(int i = 0; i < PARAMETER_COUNT; ++i) {
            full_record[i] = record[i];
        }

        p = & full_record[PARAMETER_COUNT];
        memcpy(p, ud.unexpanded, KOPIC_KUN_SIZE);
        begin = FULL_RECORD_SIZE * ( recordNumber[1] - 1 );
        putDoubleRecordUndo[1].seekp(begin);
        putDoubleRecordUndo[1].write(full_record, FULL_RECORD_SIZE);

// Setting the next record number
        recordNumber[1] += 1;
    }

}

void Kopic::centering() {
    SITE_SIZE ss = measuringScreenSize(main_width, main_height);
    kopic->resize(ss.x, ss.y, ss.w, ss.h);
}

void Kopic::clearCursor() {
    square[cell_y][cell_x]->color(FL_BACKGROUND_COLOR);
    square[cell_y][cell_x]->box(FL_FLAT_BOX);
    if(xbm_boolean_array[cell_y][cell_x]) {
        if(block) {
            square[cell_y][cell_x]->color(FL_BACKGROUND_COLOR);
            square[cell_y][cell_x]->box(FL_BORDER_BOX);
        } else {
            square[cell_y][cell_x]->color(FL_BLACK);
            square[cell_y][cell_x]->box(FL_FLAT_BOX);
        }

    }

    kopic->redraw();
}

void Kopic::CmClearBottom() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        int diagonal_y = cell_y + 1;
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < diagonal_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_FLAT_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmClearDown() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = focus_bottom - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_FLAT_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmClearEnd() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    square[i][k]->color(FL_BLACK);
                    square[i][k]->box(FL_FLAT_BOX);
                } else {
                    square[i][k]->color(FL_BACKGROUND_COLOR);
                    square[i][k]->box(FL_FLAT_BOX);
                }

            }

        }

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmClearRight() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = focus_right - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_FLAT_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmClearSide() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        int diagonal_x = cell_x + 1;
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < diagonal_x) {
                        xbm_boolean_array[i][k] = false;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_FLAT_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmClearStart() {
    startBlock(CLEAR_BLOCK);
}

void Kopic::CmCsv() {
    using namespace std;

    const bool USE_38 = false;
    const int OMITTED = 0;
    kun->manageText(OMITTED);
    kun->createKopicCsv( inheritTerms(), data_width, data_height, USE_38);

// Reading a CSV file to produce KOPIC_CSV
    if(! readCsv(KOPIC_CSV, kunCode) ) {
        ofstream file(ERROR_TEXT);
        file << "NO_CSV" << endl;
        destroy_kopic_icon();
        exit(0);
    }

    weightPane->textFields();
}

void Kopic::CmDecrement() {
    using namespace std;

    const bool USE_38 = false;
    int decrement_according_to_file = 1;
    ifstream manage(MANAGE_TEXT);
    if( manage.fail() ) {
        ofstream file(MANAGE_TEXT);
        file << "1" << endl; // decrement_according_to_file
        file << CELL_WIDTH << endl;
        file << CELL_HEIGHT << endl;
        file << "0" << endl;
    } else {
        if( manage.getline(buffer, MAIN_BUFFER_SIZE) ) {
            string b(buffer);
            stringstream sb(b);
            sb >> decrement_according_to_file;
        }

    }

    kun->manageText(decrement_according_to_file);
    kun->createKopicCsv( inheritTerms(), data_width, data_height, USE_38);

// Reading a CSV file to produce KOPIC_CSV
    if(! readCsv(KOPIC_CSV, kunCode) ) {
        ofstream file(ERROR_TEXT);
        file << "NO_CSV" << endl;
        destroy_kopic_icon();
        exit(0);
    }

    weightPane->textFields();
}

void Kopic::CmDrawDown() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        setStatusBar();
        placeCursor();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmDrawEnd() {
    if(aim == DRAW) {
        aim = NO_AIM;
        clearCursor();
    }

}

void Kopic::CmDrawInvert() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        if(xbm_boolean_array[cell_y][cell_x]) {
            xbm_boolean_array[cell_y][cell_x] = false;
        } else {
            xbm_boolean_array[cell_y][cell_x] = true;
        }

        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        setStatusBar();
        placeCursor();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();

        statusBar->take_focus();
    }

}

void Kopic::CmDrawLeft() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_x -= 1;
        if(cell_x < focus_left) {
            cell_x = ud.previous_x;

            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = ud.previous_y - 1;
            }

        }

        setStatusBar();
        placeCursor();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmDrawRight() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = ud.previous_x;

            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = ud.previous_y - 1;
            }

        }

        setStatusBar();
        placeCursor();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmDrawStart() {
    if(block) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;
    ud.previous_block_x = block_x;
    ud.previous_block_y = block_y;

    aim = DRAW;
    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_DRAW;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmDrawUp() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y -= 1;
        if(cell_y < focus_top) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        setStatusBar();
        placeCursor();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillBottom() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        int diagonal_y = cell_y + 1;
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < diagonal_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillDown() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = focus_bottom - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillEnd() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    square[i][k]->color(FL_BLACK);
                    square[i][k]->box(FL_FLAT_BOX);
                } else {
                    square[i][k]->color(FL_BACKGROUND_COLOR);
                    square[i][k]->box(FL_FLAT_BOX);
                }

            }

        }

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillRight() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = focus_right - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillSide() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        int diagonal_x = cell_x + 1;
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < diagonal_x) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmFillStart() {
    startBlock(FILL_BLOCK);
}

void Kopic::CmFocus() {
    focusPane->centering();
    focusPane->resizable(NULL);
    focusPane->set_modal();
    focusPane->show();
}

void Kopic::CmGoCorner() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x = focus_left;
    cell_y = focus_top;

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmGoDiagonal() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x = focus_right - 1;
    cell_y = focus_bottom - 1;

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmGoDown() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_y += 1;
    if(cell_y >= focus_bottom) {
        cell_y = focus_bottom - 1;
    }

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmGoJump() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    bool through = false;
    int point_x = Fl::event_x_root();
    int point_y = Fl::event_y_root();
    int upper_left_x = x();
    int upper_left_y = y() + MENU_BAR_HEIGHT;
    int upper_right_x = x() + w();
    int lower_left_y = y() + h();
    if(upper_left_x < point_x && point_x < upper_right_x) {
        if(upper_left_y < point_y && point_y < lower_left_y) {
            through = true;
        }

    }

    if(through) {
        cell_x = ( point_x - upper_left_x )/cell_width;
        if(cell_x < focus_left) {
            cell_x = focus_left;
        } else if(cell_x >= focus_right) {
            cell_x = focus_right - 1;
        }

        cell_y = ( point_y - upper_left_y )/cell_height;
        if(cell_y < focus_top) {
            cell_y = focus_top;
        } else if(cell_y >= focus_bottom) {
            cell_y = focus_bottom - 1;
        }

    }

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();

    if(aim == DRAW) {
        CmDrawInvert();
    }

    statusBar->take_focus();
}

void Kopic::CmGoLeft() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x -= 1;
    if(cell_x < focus_left) {
        cell_x = focus_left;
    }

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmGoRight() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x += 1;
    if(cell_x >= focus_right) {
        cell_x = focus_right - 1;
    }

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmGoUp() {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_y -= 1;
    if(cell_y < focus_top) {
        cell_y = focus_top;
    }

    setStatusBar();
    placeCursor();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::CmKun() {
    kun->shrink(data_width, data_height);
}

void Kopic::CmLineEnd() {
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_x = block_x;
        cell_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(xbm_boolean_array[i][k]) {
                    square[i][k]->color(FL_BLACK);
                    square[i][k]->box(FL_FLAT_BOX);
                } else {
                    square[i][k]->color(FL_BACKGROUND_COLOR);
                    square[i][k]->box(FL_FLAT_BOX);
                }

            }

        }

        setStatusBar();
        placeCursor();

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmLineRight() {
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x = focus_right - 1;
        cell_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(i == block_y) {
                    if(block_x <= k && k < focus_right) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmLineStart() {
    startBlock(LINE);
}

void Kopic::CmLineTo() {
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        if(cell_x == block_x) {
            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = focus_right - 1;
            }

            if(cell_x == block_x) {
                cell_x -= 1;
                if(cell_x < focus_left) {
                    cell_x = focus_left;
                }

                if(cell_x == block_x) {
                    return;
                }

            }

        }

        if(cell_y == block_y) {
            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = focus_bottom - 1;
            }

            if(cell_y == block_y) {
                cell_y -= 1;
                if(cell_y < focus_top) {
                    cell_y = focus_top;
                }

                if(cell_y == block_y) {
                    return;
                }

            }

        }
/*
block_y = slope * block_x + intercept
 cell_y = slope * cell_x + intercept
     dy = slope * dx + intercept
*/
        double dcx = (double)cell_x;
        double dcy = (double)cell_y;
        double dbx = (double)block_x;
        double dby = (double)block_y;
        double slope = (dby - dcy)/(dbx - dcx);
        double a_slope = fabs(slope);
        double intercept = (dby * dcx - dcy * dbx)/(dcx - dbx);

        if(a_slope < 1.0) {
            if(block_x <= cell_x) {
                if(block_y <= cell_y) {
                    gentleSlope(slope, intercept, block_x, cell_x, block_y, cell_y);
                } else {
                    gentleSlope(slope, intercept, block_x, cell_x, cell_y, block_y);
                }

            } else {
                if(block_y <= cell_y) {
                    gentleSlope(slope, intercept, cell_x, block_x, block_y, cell_y);
                } else {
                    gentleSlope(slope, intercept, cell_x, block_x, cell_y, block_y);
                }

            }

        } else {
            if(block_x <= cell_x) {
                if(block_y <= cell_y) {
                    steepSlope(slope, intercept, block_x, cell_x, block_y, cell_y);
                } else {
                    steepSlope(slope, intercept, block_x, cell_x, cell_y, block_y);
                }

            } else {
                if(block_y <= cell_y) {
                    steepSlope(slope, intercept, cell_x, block_x, block_y, cell_y);
                } else {
                    steepSlope(slope, intercept, cell_x, block_x, cell_y, block_y);
                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmLineUnder() {
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        clearCursor();

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x = block_x;
        cell_y = focus_bottom - 1;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < focus_bottom) {
                    if(k == block_x) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

        persistent = true;
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
        setStatusBar();
        placeCursor();

        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void Kopic::CmText() {
    kun->sharp_text(KOPIC_TEXT, data_width, data_height);
}

void Kopic::CmWeight() {
    weightPane->centering();
    weightPane->resizable(NULL);
    weightPane->set_modal();
    weightPane->show();
}

void Kopic::CmXbm() {
    kun->rewrite_xbm(KOPIC_XBM, data_width, data_height);
}

void Kopic::firstUndo() {
    startBlock(FIRST_UNDO);
}

void Kopic::focussing(std::string & s, int l, int t, int r, int b) {
    focus_bottom = b;
    focus_left = l;
    focus_right = r;
    focus_top = t;

    textBuffer->text( s.c_str() );
}

void Kopic::gentleSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y) {
    double dx, dy, interval_0, interval_1;

    for(int i = 0; i < XBM_HEIGHT; ++i) {
        for(int k = 0; k < XBM_WIDTH; ++k) {
            if(from_y <= i && i < to_y) {
                if(from_x <= k && k < to_x) {
                    interval_0 = (double)i;
                    interval_1 = (double)i + 1.0;
                    dx = (double)k + 0.5;
                    dy = slope * dx + intercept;
                    if(interval_0 <= dy && dy < interval_1) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

    }

    kopic->redraw();
}

void Kopic::goStart() {
// Focussing
    focus_left = 0;
    focus_right = data_width;
    focus_top = 0;
    focus_bottom = data_height;

// Reaching the upper left corner
    cell_x = focus_left;
    cell_y = focus_top;
    aim = GO;
    block = false;

// Placing squares accroding to the array
    kun = new Kun(decrement_by_n);
    kun->xbmBooleanArray(data_width, data_height);
    set_EX_OR_array();
    placeSuaresAccordingToArray();

// Neither clearing nor filling
    block_x = cell_x;
    block_y = cell_y;
    persistent = false;

// Before undo
    doubleRecordUndoClosed[0] = true;
    doubleRecordUndoClosed[1] = true;
    openDoubleRecordUndo();
    no_block.kun_size = 0;

    setStatusBar();
    placeCursor();
}

void Kopic::helpHandler() {
    versionPane->helpHandler();
}

void Kopic::layout() {
    int sub_height, sub_width, sub_x, sub_y;

    kopic->resize(main_x, main_y, main_width, main_height);

    sub_height = MENU_BAR_HEIGHT;
    sub_width = main_width;
    sub_x = 0;
    sub_y = 0;
    menu->resize(sub_x, sub_y, sub_width, sub_height);

    sub_height = STATUS_BAR_HEIGHT - 2*MARGIN;
    sub_width = main_width;
    sub_x = 0;
    sub_y = main_height - STATUS_BAR_HEIGHT + MARGIN;
    statusBar->resize(sub_x, sub_y, sub_width, sub_height);

    kopic->redraw();
}

void Kopic::moveDiamond(int new_x, int new_y) {
    if(xbm_boolean_array[block_y][block_x]) {
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(FL_BORDER_BOX);
    } else {
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(FL_FLAT_BOX);
    }

    block_x = new_x;
    block_y = new_y;
    square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
    square[block_y][block_x]->box(diamond_square);
    kopic->redraw();
}

void Kopic::placeCursor() {
    square[cell_y][cell_x]->color(FL_BACKGROUND_COLOR);
    square[cell_y][cell_x]->box(FL_ENGRAVED_BOX);

    if(block) {
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
    }

    kopic->redraw();
}

void Kopic::placeSuaresAccordingToArray() {
    for(int i = 0; i < XBM_HEIGHT; ++i) {
        for(int k = 0; k < XBM_WIDTH; ++k) {
            if( EX_OR_array[i][k] ) {
                square[i][k]->color(FL_BACKGROUND_COLOR);
                square[i][k]->box(FL_FLAT_BOX);
                if(xbm_boolean_array[i][k]) {
                    if(block) {
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    } else {
                        square[i][k]->color(FL_BLACK);
                        square[i][k]->box(FL_FLAT_BOX);
                    }

                }

            }

        }

    }

    if(block) {
        square[block_y][block_x]->color(FL_BACKGROUND_COLOR);
        square[block_y][block_x]->box(diamond_square);
    }

    kopic->redraw();
}

void Kopic::redraw() {
    Fl_Window::redraw();
}

void Kopic::set_EX_OR_array() {
    for(int m = 0; m < data_height; ++m) {
        for(int q = 0; q < data_width; ++q) {
            EX_OR_array[m][q] = true;
        }

    }

}

void Kopic::setStatusBar() {
    using namespace std;

    stringstream os;
    os << cell_x << COMMA << cell_y;
    string s = os.str();
    textBuffer->text( s.c_str() );
}

void Kopic::standardHandler() {
    centering();
    main_x = x();
    main_y = y();
    layout();
}

void Kopic::startBlock(enum AIM a) {
    if(block) {
        switch(aim) {
        case CLEAR_BLOCK:
            CmClearEnd();
            break;
        case FILL_BLOCK:
            CmFillEnd();
            break;
        case LINE:
            CmLineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];
    clearCursor();

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;
    ud.previous_block_x = block_x;
    ud.previous_block_y = block_y;
    ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

    block = true;
    placeSuaresAccordingToArray();
    moveDiamond(cell_x, cell_y);

    aim = a;
    setStatusBar();

    ud.unexpanded = & unexpanded[0];
    ud.reverse_command = UNDO_START;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void Kopic::steepSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y) {
    double dx, dy, interval_0, interval_1;

    for(int k = 0; k < XBM_WIDTH; ++k) {
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            if(from_y <= i && i < to_y) {
                if(from_x <= k && k < to_x) {
                    interval_0 = (double)k;
                    interval_1 = (double)k + 1.0;
                    dy = (double)i + 0.5;
                    dx = ( dy - intercept )/slope;
                    if(interval_0 <= dx && dx < interval_1) {
                        xbm_boolean_array[i][k] = true;
                        square[i][k]->color(FL_BACKGROUND_COLOR);
                        square[i][k]->box(FL_BORDER_BOX);
                    }

                }

            }

        }

    }

    kopic->redraw();
}

void Kopic::temporaryFileName(char *name) {
    textBuffer->text(name);
}

void Kopic::undoBlock() {
    aim = ud.previous_aim;
    clearCursor();

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    block = true;
    kunExpand(); // EX_OR_array[][]
    placeSuaresAccordingToArray();
    set_EX_OR_array();

    setStatusBar();
    placeCursor();
}

void Kopic::undoClear() {
    undoBlock();
}

void Kopic::undoDraw() {
    clearCursor();

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;
    xbm_boolean_array[cell_y][cell_x] = ud.previous_item;

    setStatusBar();
    placeCursor();
}

void Kopic::undoEnd() {
    if(ud.previous_aim == CLEAR_BLOCK || ud.previous_aim == FILL_BLOCK || ud.previous_aim == LINE) {
        moveDiamond(ud.previous_block_x, ud.previous_block_y);
    }

    aim = ud.previous_aim;
    clearCursor();

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    block = true;
    kunExpand();
    set_EX_OR_array();
    placeSuaresAccordingToArray();

    setStatusBar();
    placeCursor();
}

void Kopic::undoFill() {
    undoBlock();
}

void Kopic::undoGo() {
    clearCursor();

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    setStatusBar();
    placeCursor();
}

void Kopic::undoLine() {
    undoBlock();
}

void Kopic::undoStart() {
    if(ud.previous_aim == CLEAR_BLOCK || ud.previous_aim == FILL_BLOCK || ud.previous_aim == FIRST_UNDO || ud.previous_aim == LINE) {
        moveDiamond(ud.previous_block_x, ud.previous_block_y);
    }

    aim = ud.previous_aim;
    clearCursor();

    block = false;
    placeSuaresAccordingToArray();

    setStatusBar();
    placeCursor();
}

void Kopic::versionHandler() {
    using namespace std;

    stringstream os;
    os << "Kopic " << VERSION << " using FLTK 1.3.0";
    string s = os.str();
    textBuffer->text( s.c_str() );
    versionPane->centering();
    versionPane->resizable(NULL);
    versionPane->set_modal();
    versionPane->show();
}

void kun_cb(Fl_Widget *, void *) {
    kopic->CmKun();
}

void line_end_cb(Fl_Widget *, void *) {
    kopic->CmLineEnd();
}

void line_right_cb(Fl_Widget *, void *) {
    kopic->CmLineRight();
}

void line_start_cb(Fl_Widget *, void *) {
    kopic->CmLineStart();
}

void line_to_cb(Fl_Widget *, void *) {
    kopic->CmLineTo();
}

void line_under_cb(Fl_Widget *, void *) {
    kopic->CmLineUnder();
}

void pdf_cb(Fl_Widget *, void *) {
    kopic->helpHandler();
}

void quit_cb(Fl_Widget *, void *) {
    destroy_kopic_icon();
    exit(0);
}

void redraw_cb(Fl_Widget *, void *) {
    kopic->redraw();
}

void standard_cb(Fl_Widget *, void *) {
    kopic->standardHandler();
}

void text_cb(Fl_Widget *, void *) {
    kopic->CmText();
}

void timer_cb(void *) {
    using namespace std;     
     
    if( kopicCsvTouched() ) {
        PICK_CODE pc = weightPane->textFields();
        if(pc.code != UNPICKED) {
            ofstream file(ERROR_TEXT);
            file << "kopicCsvTouched(): pc.code != UNPICKED" << endl;

            destroy_kopic_icon();
            exit(0);
        }

    }

    Fl::repeat_timeout(NONSAMPLING_PERIOD, timer_cb);
}

void undo_cb(Fl_Widget *, void *) {
    kopic->undoThat();
}

void version_cb(Fl_Widget *, void *) {
    kopic->versionHandler();
}

void weight_cb(Fl_Widget *, void *) {
    kopic->CmWeight();
}

void xbm_cb(Fl_Widget *, void *) {
    kopic->CmXbm();
}

