#include "kun.h"

bool EX_OR_array[XBM_HEIGHT][XBM_WIDTH];
bool mirror_images[XBM_HEIGHT][XBM_WIDTH];
bool xbm_boolean_array[XBM_HEIGHT][XBM_WIDTH];
char data_bits[ XBM_HEIGHT * XBM_WIDTH/BITS ];
char h[256][3];
extern long untouched;
std::string trueKopicText;
unsigned int shift[8] = {
    B00000001,
    B00000010,
    B00000100,
    B00001000,
    B00010000,
    B00100000,
    B01000000,
    B10000000
};

bool itemsTreatedAsFalse(char *file_name) {
    using namespace std;

// Acquiring items from FALSE_TEXT so that items can be treated as false.
    ifstream false_text(FALSE_TEXT);
    if( false_text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << FALSE_TEXT << endl;
        return false;
    }

    string *p = new string("");
    string items[ITEM_COUNT];
    for(int k = 0; k < ITEM_COUNT; k++) {
        items[k] = *p;
    }

    char buffer[LARGE_BUFFER_SIZE];
    for(int k = 0; k < ITEM_COUNT; k++) {
        if( false_text.getline(buffer, LARGE_BUFFER_SIZE) ) {
            delete p;
            p = new string(buffer);
            items[k] = *p;
        } else {
            break;
        }

    }

    false_text.close();
    ifstream text(file_name);
    if( text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << file_name << endl;
        return false;
    }

    bool zenkaku = false;
    char *b;
    char *q;
    char data[LARGE_BUFFER_SIZE];
    char item[ FALSE_ITEM_SIZE + 1 ];
    int c, h, item_size, w;
    unsigned char u;

    for(h = 0; ; h++) {
        if( text.getline(buffer, LARGE_BUFFER_SIZE) ) {

// Software replaces false characters with carets.
            for(int k = 0; k < ITEM_COUNT; k++) {
                item_size = items[k].length();
                if(item_size == 0) {
                    break;
                }

                b = & buffer[0];
                data[0] = '\0';
                strcpy(item, items[k].c_str() );
                for(;;) {
                    q = strstr(b, item);
                    if(q == NULL) {
                        strcat(data, b);
                        break;
                    } else {
                        *q = '\0';
                        strcat(data, b);
                        strcat(data, CARET);
                        b = q + item_size;
                    }

                }

                strcpy(buffer, data);
            }

// Software treats carets as false.
            w = 0;
            for(int k = 0; buffer[k] != '\0'; k++) {
                u = (unsigned char )buffer[k];
                c = (int)u;

                if(zenkaku) {
                    xbm_boolean_array[h][w++] = true;

                    zenkaku = false;
                    continue;
                }

                if(0x81 <= c && c <= 0xFC) {
                    if(KANA_KUTEN <= c && c <= 0xDF) { // 
                        zenkaku = false;
                        xbm_boolean_array[h][w++] = true;
                    } else {
                        zenkaku = true;
                    }

                } else if(c == CARET_C) {
                    zenkaku = false;
                    xbm_boolean_array[h][w++] = false;
                } else {
                    zenkaku = false;
                    xbm_boolean_array[h][w++] = true;
                }

            }

        } else {
            break;
        }

    }

    text.close();

    int data_height = h;
    int data_width = w;
    int decrement_by_n = 0;
    Kun *kun = new Kun(decrement_by_n);
    kun->rewrite_xbm(KOPIC_XBM, data_width, data_height);

    delete kun;
    delete p;
    return true;
}

bool itemsTreatedAsTrue(char *file_name) {
    using namespace std;

// Acquiring items from TRUE_TEXT so that items can be treated as true.
    ifstream true_text(TRUE_TEXT);
    if( true_text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << TRUE_TEXT << endl;
        return false;
    }

    string *p = new string("");
    string items[ITEM_COUNT];
    for(int k = 0; k < ITEM_COUNT; k++) {
        items[k] = *p;
    }

    char buffer[LARGE_BUFFER_SIZE];
    for(int k = 0; k < ITEM_COUNT; k++) {
        if( true_text.getline(buffer, LARGE_BUFFER_SIZE) ) {
            delete p;
            p = new string(buffer);
            items[k] = *p;
        } else {
            break;
        }

    }

    true_text.close();
    ifstream in(file_name);
    if( in.fail() ) {
        ofstream file(ERROR_TEXT);
        file << file_name << endl;
        return false;
    }

    char *b;
    char *q;
    char data[LARGE_BUFFER_SIZE];
    char item[ TRUE_ITEM_SIZE + 1 ];
    const bool SERIAL_NUMBER = true;
    const string QUOTE("\"");
    int h, item_size;
    TimeName tt(TRU, TEXT_FILE);
    trueKopicText = tt.temporaryName(SERIAL_NUMBER);
    ofstream kopic_text( trueKopicText.c_str() );

    for(h = 0; ; h++) {
        if( in.getline(buffer, LARGE_BUFFER_SIZE) ) {

// Software replaces true characters with quotes.
            for(int k = 0; k < ITEM_COUNT; k++) {
                item_size = items[k].length();
                if(item_size == 0) {
                    break;
                }

                b = & buffer[0];
                data[0] = '\0';
                strcpy(item, items[k].c_str() );
                for(;;) {
                    q = strstr(b, item);
                    if(q == NULL) {
                        strcat(data, b);
                        break;
                    } else {
                        *q = '\0';
                        strcat(data, b);
                        strcat(data, QUOTE.c_str() );
                        b = q + item_size;
                    }

                }

                strcpy(buffer, data);
            }

        } else {
            break;
        }

        kopic_text << buffer << endl;
    }

    kopic_text.close();
    in.close();
    delete p;
    return true;
}

bool Kun::rewrite_xbm(char *file_name, int data_width, int data_height) {
    using namespace std;

    const int DATA_HEIGHT_1 = data_height - 1;
    const int ITEM_WIDTH_1 = ITEM_WIDTH - 1;
    int q;
    unsigned int b;

    mirrorImages(data_width, data_height);

    ofstream xbm_file(file_name);
    if( xbm_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream xbm_file(file_name): " << file_name << endl;
        return false;
    }

    xbm_file << "#define data_width " << data_width << endl
        << "#define data_height " << data_height << endl
        << "static char data_bits[] = {" << endl;

    for(int m = 0; m < data_height; m++) {
        q = 0;
        for(int k = 0; k < data_width; k += ITEM_WIDTH) {
            b = 0;

            for(int p = ITEM_WIDTH_1; p >= 0; p--, q++) {
                if(mirror_images[m][q]) {
                    b |= shift[p];
                }

            }

            if(m == DATA_HEIGHT_1 && q == data_width) {
                xbm_file << ZERO_X << &h[b][0];
            } else {
                xbm_file << ZERO_X << &h[b][0] << ",";
            }

        }

        xbm_file << endl;
    }

    xbm_file << "};" << endl;
    return true;
}

bool Kun::sharp_text(char *file_name, int data_width, int data_height) {
    using namespace std;

    ofstream text(file_name);
    if( text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream text(file_name): " << file_name << endl;
        return false;
    }

    for(int m = 0; m < data_height; m++) {
        for(int q = 0; q < data_width; q++) {
            if(xbm_boolean_array[m][q]) {
                text << SHARP;
            } else {
                text << SPACE;
            }

        }

        text << NEW_LINE;
    }

    return true;
}

bool kunExpand(char *file_name) {
    using namespace std;

    bool expanded[ XBM_HEIGHT * XBM_WIDTH ];
    char buffer[LARGE_BUFFER_SIZE];
    const int XBM_HEIGHT_1 = XBM_HEIGHT + 1;
    const string NEW_LINE("\n");
    int black_or_white, count, data_height, DEL_count, n, q, sum, u;
    int data_width[ XBM_HEIGHT + 1 ];

// Using the file as binary
    ifstream kun_file(file_name, ios::binary);
    if( kun_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ifstream kun_file(file_name, ios::binary): " << file_name << endl;
        return false;
    }

    kun_file.seekg(0, ios::end);
    streampos length = kun_file.tellg();
    long file_size = length;

    kun_file.seekg(0, ios::beg);
    kun_file.read(buffer, length);
    kun_file.close();

    DEL_count = 0;
    n = 0;
    q = 0;
    sum = 0;
    for(int k = SIGNATURE; k < file_size && DEL_count < XBM_HEIGHT_1; ++k, ++q) {
        if(buffer[k] == DEL) {
            data_width[DEL_count] = sum;
            DEL_count += 1;
            q = 0;
            sum = 0;
            continue;
        }

        count = (int)buffer[k];
        sum += count;
        black_or_white = q%2;
        switch(black_or_white) {
        case BLACK:
            for(u = 0; u < count; u++) {
                expanded[n++] = true;
            }

            break;
        case WHITE:
            for(u = 0; u < count; u++) {
                expanded[n++] = false;
            }

            break;
        }

    }

// Checking if data width is constant.
    data_height = DEL_count - 1;
    for(int m = 2; m < data_height; m++) {
        if(data_width[m] == data_width[1]) {
            continue;
        } else {
            ofstream file(ERROR_TEXT);
            file << "data_width[1] = " << data_width[1] << endl 
                << "data_width[" << m << "] = " << data_width[m] << endl;
            return false;
        }

    }

    n = 0;
    ofstream text(KOPIC_TEXT);
    if( text.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream text(KOPIC_TEXT)" << endl;
        return false;
    }

    for(int m = 0; m < data_height; m++) {
        for(q = 0; q < data_width[1]; q++) {
            xbm_boolean_array[m][q] = expanded[n++];

            if(xbm_boolean_array[m][q]) {
                text << "#";
            } else {
                text << " ";
            }

        }

        text << NEW_LINE;
    }

    return true;
}

int checkExtension(char *file_name) {
    char *after_dot;
    int extension = TEXT;

    after_dot = strchr(file_name, '.');
    if(after_dot == NULL) {
        return extension;
    }

    if(! strcmp(after_dot, ".csv") ) {
        extension = CSV;
    } else if(! strcmp(after_dot, ".xbm") ) {
        extension = XBM;
    } else if(! strcmp(after_dot, ".kun") ) {
        extension = KUN;
    }

    return extension;
}

int Kun::createKopicCsv(std::string essential, int data_width, int data_height, bool from_not_38) {
    using namespace std;

    memset(run_length, 0, KOPIC_KUN_SIZE);
    int m = 0;
    encoding_size = 0;

    run_length[encoding_size] = DEL;
    encoding_size += 1;
    counting(data_width, m);

    for(m = 1; m < data_height; m++) {
        if(check) {
            run_length[encoding_size] = black;
        } else {
            run_length[encoding_size] = white;
        }

        encoding_size += 1;

        run_length[encoding_size] = DEL;
        encoding_size += 1;
        counting(data_width, m);
    }

    if(check) {
        run_length[encoding_size] = black;
    } else {
        run_length[encoding_size] = white;
    }

    encoding_size += 1;

    run_length[encoding_size] = DEL;
    encoding_size += 1;

    ofstream csv_file(KOPIC_CSV);
    if( csv_file.fail() ) {
        return KUN_FILE_ERROR;
    }

    string b01("01,"); string b02("02,"); string b03("03,"); string b04("04,"); string b05("05,"); string b06("06,"); string b07("07,"); string b08("08,"); string b09("09,"); string b10("10,");
    string b11("11,"); string b12("12,"); string b13("13,"); string b14("14,"); string b15("15,"); string b16("16,"); string b17("17,"); string b18("18,"); string b19("19,"); string b20("20,");
    string b21("21,"); string b22("22,"); string b23("23,"); string b24("24,"); string b25("25,"); string b26("26,"); string b27("27,"); string b28("28,"); string b29("29,"); string b30("30,");
    string b31("31,"); string b32("32,"); string b33("33,"); string b34("34,"); string b35("35,"); string b36("36,"); string b37("37,"); string b38("38,");

    string d[ ALL + 2 ];
    d[0] = EMPTY;
    d[1] = b01; d[2] = b02; d[3] = b03; d[4] = b04; d[5] = b05; d[6] = b06; d[7] = b07; d[8] = b08; d[9] = b09; d[10] = b10;
    d[11] = b11; d[12] = b12; d[13] = b13; d[14] = b14; d[15] = b15; d[16] = b16; d[17] = b17; d[18] = b18; d[19] = b19; d[20] = b20;
    d[21] = b21; d[22] = b22; d[23] = b23; d[24] = b24; d[25] = b25; d[26] = b26; d[27] = b27; d[28] = b28; d[29] = b29; d[30] = b30;
    d[31] = b31; d[32] = b32; d[33] = b33; d[34] = b34; d[35] = b35; d[36] = b36; d[37] = b37; 

    if(from_not_38) { // Use From, not 38.
        string from("From,");
        d[38] = from;
    } else {
        d[38] = b38;
    }

    const int D_ARRAY_SIZE = ALL + 1;
    int count, value;
    int DEL_count = 0;
    int sum = 0;
    for(int k = 0; k < encoding_size && DEL_count < D_ARRAY_SIZE; ++k) {
        if(run_length[k] == DEL) {
            DEL_count += 1;
            if(sum > 0) {
                csv_file << endl;
            }

            csv_file << d[DEL_count];
            sum = 0;

// After run_length[k] equals DEL, software omits the first zero.
            ++k;
            if( k < encoding_size && DEL_count < D_ARRAY_SIZE ) {
                ++k;
                if( k < encoding_size && DEL_count < D_ARRAY_SIZE ) {
// After omitting the first zero, software writes a value.
                    count = (int)run_length[k];
                    sum += count;
                    value = count - decrement_by_n;
                    if(value < 0) {
                        value = 0;
                    }

                    csv_file << value;
                    continue;
                }

            }

        }

        count = (int)run_length[k];
        sum += count;
    }

    csv_file << essential;
    untouched = modified_file(KOPIC_CSV);
    return encoding_size;
}

int Kun::shrink(char *unexpanded, int data_width, int data_height) {
    memset(run_length, 0, KOPIC_KUN_SIZE);
    int m = 0;
    encoding_size = 0;

    run_length[encoding_size] = DEL;
    encoding_size += 1;
    counting(data_width, m);

    for(m = 1; m < data_height; m++) {
        if(check) {
            run_length[encoding_size] = black;
        } else {
            run_length[encoding_size] = white;
        }

        encoding_size += 1;

        run_length[encoding_size] = DEL;
        encoding_size += 1;
        counting(data_width, m);
    }

    if(check) {
        run_length[encoding_size] = black;
    } else {
        run_length[encoding_size] = white;
    }

    encoding_size += 1;

    run_length[encoding_size] = DEL;
    encoding_size += 1;

// signature of 8 bytes
    unexpanded[0] = '.';
    unexpanded[1] = 'K';
    unexpanded[2] = 'U';
    unexpanded[3] = 'N';
    unexpanded[4] = (char)data_height;
    unexpanded[5] = (char)data_width;
    unexpanded[6] = '1';
    unexpanded[7] = '0';
    int unexpanded_size = 8;

    char *p = & unexpanded[8];
    memset(p, 0, KOPIC_KUN_SIZE);
    memcpy(p, run_length, encoding_size);

    unexpanded_size += encoding_size;
    return unexpanded_size;
}

int Kun::shrink(int data_width, int data_height) {
    using namespace std;

    int m = 0;
    encoding_size = 0;

    run_length[encoding_size] = DEL;
    encoding_size += 1;
    counting(data_width, m);

    for(m = 1; m < data_height; m++) {
        if(check) {
            run_length[encoding_size] = black;
        } else {
            run_length[encoding_size] = white;
        }

        encoding_size += 1;

        run_length[encoding_size] = DEL;
        encoding_size += 1;
        counting(data_width, m);
    }

    if(check) {
        run_length[encoding_size] = black;
    } else {
        run_length[encoding_size] = white;
    }

    encoding_size += 1;

    run_length[encoding_size] = DEL;
    encoding_size += 1;

    ofstream kun_file(KOPIC_KUN, ios::binary);
    if( kun_file.fail() ) {
        return KUN_FILE_ERROR;
    }

// signature of 8 bytes
    char signature[SIGNATURE];
    signature[0] = '.';
    signature[1] = 'K';
    signature[2] = 'U';
    signature[3] = 'N';
    signature[4] = (char)data_height;
    signature[5] = (char)data_width;
    signature[6] = '1';
    signature[7] = '0';

    kun_file.write(signature, SIGNATURE);
    kun_file.write(run_length, encoding_size);
    return encoding_size;
}

KUN_CODE readXbm(int argc, char *argv[]) {
    using namespace std;

    bool csv = false;
    bool kun_shrink = false;
    bool remove_first = true;
    bool sharp_symbols = false;
    char *b;
    char *stop;
    char buffer[LARGE_BUFFER_SIZE];
    const bool COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;
    const string COMMA(",");
    const string CSV_DECREMENT("-cd");
    const string CSV_FILE("-c");
    const string EASY_TO_SEE("-t");
    const string FROM_NOT_38("-38-");
    const string FULL_SWING("-f");
    const string GROUPING("-g");
    const string KUN_FILE("-k");
    const string MAPPING("-m");
    const string NEW_LINE("\n");
    const string NEW_XBM("-n");
    const string NO_EDITING("-e-");
    const string NO_REMOVING("-r-");
    const string NO_WEIGHTING("-w-");
    const string OUTPUT("-o");
    const string PRNG_MT = "-pm";
    const string PRNG_XORSHIFT = "-px";
    const string SIZE("-s");
    const string USE_SQUARE_NOT_DIAMOND("-d-");
    const string version_comments("-VC");
    const string version_guide("-V");
    const string XBM_RECOVERY("-y");
    const string ZERO_X("0x");
    int decrement_according_to_file = 1;
    int cell_height = CELL_HEIGHT;
    int cell_width = CELL_WIDTH;
    int diamond = DIAMOND;
    int k, u;
    KUN_CODE kc;
    Numbered *n = new Numbered("-cd2");
    string *fileName = new string(KOPIC_XBM);
    string *p = new string("");
    string argument;
    unsigned int d;

    ifstream manage(MANAGE_TEXT);
    if( manage.fail() ) {
        ofstream file(MANAGE_TEXT);
        file << "1" << endl; // decrement_according_to_file 
        file << CELL_WIDTH << endl;
        file << CELL_HEIGHT << endl;
        file << "0" << endl; // kc.diamond
    } else {
        if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
            string b(buffer);
            stringstream sb(b);
            sb >> decrement_according_to_file;
            if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                string w(buffer);
                stringstream sw(w);
                sw >> cell_width;
                if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                    string h(buffer);
                    stringstream sh(h);
                    sh >> cell_height;
                    if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                        string d(buffer);
                        stringstream sd(d);
                        sd >> diamond;
                    }
    
                }

            }

        }

    }

    kc.cell_height = CELL_HEIGHT;
    kc.cell_width = CELL_WIDTH;
    kc.decrement_by_n = decrement_according_to_file;
    kc.defectiveCsv = true;
    kc.diamond = diamond;
    kc.from_not_38 = false;
    kc.full_swing = false;
    kc.grouping = false;
    kc.mapping = false;
    kc.newXbm = false;
    kc.outputLines = KOPIC_REPEAT - KOPIC_FROM;
    kc.prng = MERSENNE_TWISTER;
    kc.weight = true;

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(argument == CSV_FILE) {
            csv = true;
        } else if(argument == EASY_TO_SEE) {
            sharp_symbols = true;
        } else if(argument == FROM_NOT_38) {
            kc.from_not_38 = true; // Use From, not 38.
        } else if(argument == FULL_SWING) {
            kc.full_swing = true;
        } else if(argument == GROUPING) {
            kc.grouping = true;
        } else if(argument == KUN_FILE) {
            kun_shrink = true;
        } else if(argument == MAPPING) {
            kc.mapping = true;
        } else if(argument == NEW_XBM) {
            kc.newXbm = true;
        } else if(argument == NO_EDITING) {
            kc.defectiveCsv = false;
        } else if(argument == NO_REMOVING) {
            remove_first = false;
        } else if(argument == NO_WEIGHTING) {
            kc.weight = false;
        } else if(argument == PRNG_MT) {
            kc.prng = MERSENNE_TWISTER;
        } else if(argument == PRNG_XORSHIFT) {
            kc.prng = XORSHIFT;
        } else if(argument == USE_SQUARE_NOT_DIAMOND) {
            kc.diamond = SHOEBOX;
        } else if(argument == version_guide) {
            guide(WITHOUT_COMMENTS);
            delete fileName; delete n; delete p;
            kc.code = VERSION_GUIDE;
            return kc;
        } else if(argument == version_comments) {
            guide(COMMENTS);
            delete fileName; delete n; delete p;
            kc.code = VERSION_COMMENTS;
            return kc;
        } else if(argument == XBM_RECOVERY) {
            createKopicXbm();
            delete fileName; delete n; delete p;
            kc.code = RECOVERY;
            return kc;
        } else {
            d = argument.find(CSV_DECREMENT);
            if(d != string::npos) {
                delete n;
                strcpy(buffer, argument.c_str() );
                n = new Numbered(buffer);
                kc.decrement_by_n = n->number();
                if( n->parameter() == CSV_DECREMENT ) {
                    csv = true;
                    continue;
                }

                kc.decrement_by_n = 0;
            }

            d = argument.find(OUTPUT);
            if(d != string::npos) {
                delete n;
                strcpy(buffer, argument.c_str() );
                n = new Numbered(buffer);
                kc.outputLines = n->number();
                if( n->parameter() == OUTPUT ) {
                    continue;
                }

                kc.outputLines = KOPIC_REPEAT - KOPIC_FROM;
            }

            d = argument.find(SIZE);
            if(d != string::npos) {
                delete n;
                strcpy(buffer, argument.c_str() );
                n = new Numbered(buffer);
                kc.cell_height = n->number();
                if( n->trimmed_sequence() ) {
                    kc.cell_width = n->subnumber();
                    if( n->parameter() == SIZE ) {
                        continue;
                    }

                }

                kc.cell_height = CELL_HEIGHT;
                kc.cell_width = CELL_WIDTH;
            }

            delete fileName;
            fileName = new string(argv[i]);
        }

    }

    delete n;
    if(remove_first) {
        createRemoveErrorText();
        removeTemporaryFiles();
    }

    expressedAsHexadecimal();
    ifstream trial(FALSE_TEXT);
    if( trial.fail() ) {
        ofstream file(FALSE_TEXT);
        file << " " << endl;
        file << "0" << endl;
        file << "@" << endl; // Shift_JIS
    } else {
        trial.close();
    }

    strcpy(kc.file_name, fileName->c_str() );
    delete fileName;
    delete p;
    int extension = checkExtension(kc.file_name);
    switch(extension) {
    case CSV:
        kc.defectiveCsv = true;
        kc.code = CSV_SPECIFIED;
        return kc;
    case KUN:
        if( kunExpand(kc.file_name) ) {
            kc.code = KUN_EXPAND;
            return kc;
        }

        kc.code = XBM_FILE_ERROR;
        return kc;
    case TEXT:
        if( itemsTreatedAsTrue(kc.file_name) ) {
            strcpy(buffer, trueKopicText.c_str() );
            if( itemsTreatedAsFalse(buffer) ) {
                kc.code = TREATED_AS_FALSE;
                return kc;
            }

        } else {
            if( itemsTreatedAsFalse(kc.file_name) ) {
                kc.code = TREATED_AS_FALSE;
                return kc;
            }

        }

        kc.code = XBM_FILE_ERROR;
        return kc;
    }

    if(! kc.defectiveCsv) {
// Regardless of kopic.xbm, software preserves kopic.csv because it is perfect.
        strcpy(kc.file_name, KOPIC_CSV);
        kc.code = CSV_SPECIFIED;
        return kc;
    }

    ifstream xbm_file(kc.file_name);
    if( xbm_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << kc.file_name << endl;
        kc.code = XBM_FILE_ERROR;
        return kc;
    }

// Reading height and width
    p = new string("");
    while( xbm_file.getline(buffer, LARGE_BUFFER_SIZE) ) {
        delete p;
        p = new string(buffer);
        d = p->find("w");
        if(d == string::npos) {
            d = p->find("g");
            if(d == string::npos) {
                break;
            } else {
                u = strcspn(buffer, N_0TO9);
                b = &buffer[u];
                kc.data_height = (int)strtol(b, &stop, 10);
            }

        } else {
            u = strcspn(buffer, N_0TO9);
            b = &buffer[u];
            kc.data_width = (int)strtol(b, &stop, 10);
        }

    }

// Reading bits to produce arrays 
    k = 0; // data_bits[k]
    string head, tail;
    while( xbm_file.getline(buffer, LARGE_BUFFER_SIZE) ) {
        delete p;
        p = new string(buffer);
        d = p->find("s");
        if(d == string::npos) {
            tail = *p + NEW_LINE;

            for(;;) {
                d = tail.find(ZERO_X);
                if(d == string::npos) {
                    break;
                }

                tail = tail.substr(d);
                d = tail.find(COMMA);
                if(d == string::npos) {
                    d = tail.find(NEW_LINE);
                    if(d == string::npos) {
                        break;
                    }

                }

                head = tail.substr(0, d);
                tail = tail.substr(d);
                data_bits[k++] = (char)strtol( head.c_str(), &stop, 0);
            }

        }

    }

    delete p;
    ifstream test(KOPIC_CSV);
    if( test.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "Software may produce kopic.csv from kopic.xbm" << endl;
        csv = true;
    }

    Kun *kun = new Kun(kc.decrement_by_n);
    kun->xbmBooleanArray(kc.data_width, kc.data_height);

    if(csv) {
        kun->createKopicCsv( standardTerms(), kc.data_width, kc.data_height, kc.from_not_38);
        delete kun;
        kc.code = XBM_TO_CSV;
        return kc;
    }

    if(kun_shrink) {
        kun->shrink(kc.data_width, kc.data_height);
        delete kun;
        kc.code = KUN_SHRINK;
        return kc;
    }

    if(sharp_symbols) {
        kun->sharp_text(KOPIC_TEXT, kc.data_width, kc.data_height);
        delete kun;
        kc.code = SHARP_TEXT;
        return kc;
    }

    kun->createKopicCsv( inheritTerms(), kc.data_width, kc.data_height, kc.from_not_38);
    delete kun;
    kc.code = XBM_READ;
    return kc;
}

std::string inheritTerms() {
    using namespace std;

    ifstream csv_file(KOPIC_CSV);
    if( csv_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ifstream csv_file(KOPIC_CSV)" << endl;
        return standardTerms();
    }

    bool useFrom = false;
    char buffer[BUFFER_SIZE];
    const int FROM_COMMA_SIZE = 5;
    const int LOG_COMMA_SIZE = 4;
    const int REPEAT_COMMA_SIZE = 7;
    const int SETTING_COMMA_SIZE = 8;
    const string FROM_COMMA("From,");
    const string LOG_COMMA("Log,");
    const string NEW_LINE("\n");
    const string REPEAT_COMMA("Repeat,");
    const string SETTING_COMMA("Setting,");
    string *p = new string("");
    string term;
    stringstream os;
    unsigned int q;
    while( csv_file.getline(buffer, BUFFER_SIZE) ) {
        delete p;
        p = new string(buffer);

        q = p->find(FROM_COMMA);
        if(q != string::npos) {
            useFrom = true;
            q += FROM_COMMA_SIZE;
            term = p->substr(q);
            os << term << NEW_LINE;
            continue;
        }

        q = p->find(LOG_COMMA);
        if(q != string::npos) {
            q += LOG_COMMA_SIZE;
            term = p->substr(q);
            os << LOG_COMMA << term << NEW_LINE;
            continue;
        }

        q = p->find(REPEAT_COMMA);
        if(q != string::npos) {
            q += REPEAT_COMMA_SIZE;
            term = p->substr(q);
            os << REPEAT_COMMA << term << NEW_LINE;
            continue;
        }

        q = p->find(SETTING_COMMA);
        if(q != string::npos) {
            q += SETTING_COMMA_SIZE;
            term = p->substr(q);
            os << SETTING_COMMA << term << NEW_LINE;
            continue;
        }

    }

    string fourLines;
    if(useFrom) {
        fourLines = os.str();
    } else {
        fourLines = "0" + NEW_LINE + os.str();
    }

    return fourLines;
}

std::string standardTerms() {
    using namespace std;

    const string NEW_LINE("\n");
    stringstream os;
    os << "0" << NEW_LINE;
    os << "Log,KO.LOG" << NEW_LINE;
    os << "Repeat,420" << NEW_LINE;
    os << "Setting,123456" << NEW_LINE;
    string fourLines = os.str();
    return fourLines;
}

void createKopicXbm() {
    using namespace std;

    ofstream xbm_file(KOPIC_XBM);
    xbm_file << "#define data_width " << XBM_WIDTH << endl 
        << "#define data_height " << XBM_HEIGHT << endl 
        << "static char data_bits[] = {" << endl 
        << "0x00,0x00,0x40,0x00,0x00," << endl 
        << "0x00,0x00,0x80,0x00,0x00," << endl 
        << "0x00,0x00,0x00,0x01,0x00," << endl 
        << "0x00,0x00,0x00,0x02,0x00," << endl 
        << "0x00,0x00,0x00,0x02,0x00," << endl 
        << "0x00,0x00,0x00,0x04,0x00," << endl 
        << "0x00,0x00,0x00,0x04,0x00," << endl 
        << "0x00,0x00,0x00,0x04,0x00," << endl 
        << "0x00,0x00,0x00,0x04,0x00," << endl 
        << "0x00,0x00,0x00,0x04,0x00," << endl 
        << "0x00,0x00,0x00,0x02,0x00," << endl 
        << "0x00,0x00,0x00,0x02,0x00," << endl 
        << "0x00,0x00,0x00,0x02,0x00," << endl 
        << "0x00,0x00,0x00,0x01,0x00," << endl 
        << "0x00,0x00,0x00,0x01,0x00," << endl 
        << "0x00,0x00,0x80,0x00,0x00," << endl 
        << "0x00,0x00,0x80,0x00,0x00," << endl 
        << "0x00,0x00,0x40,0x00,0x00," << endl 
        << "0x00,0x00,0x20,0x00,0x00," << endl 
        << "0x00,0x00,0x20,0x00,0x00," << endl 
        << "0x00,0x00,0x10,0x00,0x00," << endl 
        << "0x00,0x00,0x08,0x00,0x00," << endl 
        << "0x00,0x00,0x08,0x00,0x00," << endl 
        << "0x00,0x00,0x04,0x00,0x00," << endl 
        << "0x00,0x00,0x02,0x00,0x00," << endl 
        << "0x00,0x00,0x02,0x00,0x00," << endl 
        << "0x00,0x00,0x01,0x00,0x00," << endl 
        << "0x00,0x00,0x01,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x40,0x00,0x00,0x00," << endl 
        << "0x00,0x80,0x00,0x00,0x00," << endl 
        << "0x00,0x00,0x01,0x00,0x00," << endl 
        << "0x00,0x00,0x01,0x00,0x00," << endl 
        << "0x00,0x00,0x02,0x00,0x00," << endl 
        << "0x00,0x00,0x0c,0x00,0x00," << endl 
        << "0x00,0x00,0x10,0x00,0x00" << endl 
        << "};" << endl;
}

void expressedAsHexadecimal() {
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0a"); strcpy(&h[ 11][0], "0b");
    strcpy(&h[ 12][0], "0c"); strcpy(&h[ 13][0], "0d"); strcpy(&h[ 14][0], "0e"); strcpy(&h[ 15][0], "0f"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1a"); strcpy(&h[ 27][0], "1b"); strcpy(&h[ 28][0], "1c"); strcpy(&h[ 29][0], "1d"); strcpy(&h[ 30][0], "1e"); strcpy(&h[ 31][0], "1f"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2a"); strcpy(&h[ 43][0], "2b"); strcpy(&h[ 44][0], "2c"); strcpy(&h[ 45][0], "2d"); strcpy(&h[ 46][0], "2e"); strcpy(&h[ 47][0], "2f");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3a"); strcpy(&h[ 59][0], "3b");
    strcpy(&h[ 60][0], "3c"); strcpy(&h[ 61][0], "3d"); strcpy(&h[ 62][0], "3e"); strcpy(&h[ 63][0], "3f"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4a"); strcpy(&h[ 75][0], "4b"); strcpy(&h[ 76][0], "4c"); strcpy(&h[ 77][0], "4d"); strcpy(&h[ 78][0], "4e"); strcpy(&h[ 79][0], "4f"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5a"); strcpy(&h[ 91][0], "5b"); strcpy(&h[ 92][0], "5c"); strcpy(&h[ 93][0], "5d"); strcpy(&h[ 94][0], "5e"); strcpy(&h[ 95][0], "5f");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6a"); strcpy(&h[107][0], "6b");
    strcpy(&h[108][0], "6c"); strcpy(&h[109][0], "6d"); strcpy(&h[110][0], "6e"); strcpy(&h[111][0], "6f"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7a"); strcpy(&h[123][0], "7b"); strcpy(&h[124][0], "7c"); strcpy(&h[125][0], "7d"); strcpy(&h[126][0], "7e"); strcpy(&h[127][0], "7f"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8a"); strcpy(&h[139][0], "8b"); strcpy(&h[140][0], "8c"); strcpy(&h[141][0], "8d"); strcpy(&h[142][0], "8e"); strcpy(&h[143][0], "8f");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9a"); strcpy(&h[155][0], "9b");
    strcpy(&h[156][0], "9c"); strcpy(&h[157][0], "9d"); strcpy(&h[158][0], "9e"); strcpy(&h[159][0], "9f"); strcpy(&h[160][0], "a0"); strcpy(&h[161][0], "a1"); strcpy(&h[162][0], "a2"); strcpy(&h[163][0], "a3"); strcpy(&h[164][0], "a4"); strcpy(&h[165][0], "a5"); strcpy(&h[166][0], "a6"); strcpy(&h[167][0], "a7");
    strcpy(&h[168][0], "a8"); strcpy(&h[169][0], "a9"); strcpy(&h[170][0], "aa"); strcpy(&h[171][0], "ab"); strcpy(&h[172][0], "ac"); strcpy(&h[173][0], "ad"); strcpy(&h[174][0], "ae"); strcpy(&h[175][0], "af"); strcpy(&h[176][0], "b0"); strcpy(&h[177][0], "b1"); strcpy(&h[178][0], "b2"); strcpy(&h[179][0], "b3");
    strcpy(&h[180][0], "b4"); strcpy(&h[181][0], "b5"); strcpy(&h[182][0], "b6"); strcpy(&h[183][0], "b7"); strcpy(&h[184][0], "b8"); strcpy(&h[185][0], "b9"); strcpy(&h[186][0], "ba"); strcpy(&h[187][0], "bb"); strcpy(&h[188][0], "bc"); strcpy(&h[189][0], "bd"); strcpy(&h[190][0], "be"); strcpy(&h[191][0], "bf");
    strcpy(&h[192][0], "c0"); strcpy(&h[193][0], "c1"); strcpy(&h[194][0], "c2"); strcpy(&h[195][0], "c3"); strcpy(&h[196][0], "c4"); strcpy(&h[197][0], "c5"); strcpy(&h[198][0], "c6"); strcpy(&h[199][0], "c7"); strcpy(&h[200][0], "c8"); strcpy(&h[201][0], "c9"); strcpy(&h[202][0], "ca"); strcpy(&h[203][0], "cb");
    strcpy(&h[204][0], "cc"); strcpy(&h[205][0], "cd"); strcpy(&h[206][0], "ce"); strcpy(&h[207][0], "cf"); strcpy(&h[208][0], "d0"); strcpy(&h[209][0], "d1"); strcpy(&h[210][0], "d2"); strcpy(&h[211][0], "d3"); strcpy(&h[212][0], "d4"); strcpy(&h[213][0], "d5"); strcpy(&h[214][0], "d6"); strcpy(&h[215][0], "d7");
    strcpy(&h[216][0], "d8"); strcpy(&h[217][0], "d9"); strcpy(&h[218][0], "da"); strcpy(&h[219][0], "db"); strcpy(&h[220][0], "dc"); strcpy(&h[221][0], "dd"); strcpy(&h[222][0], "de"); strcpy(&h[223][0], "df"); strcpy(&h[224][0], "e0"); strcpy(&h[225][0], "e1"); strcpy(&h[226][0], "e2"); strcpy(&h[227][0], "e3");
    strcpy(&h[228][0], "e4"); strcpy(&h[229][0], "e5"); strcpy(&h[230][0], "e6"); strcpy(&h[231][0], "e7"); strcpy(&h[232][0], "e8"); strcpy(&h[233][0], "e9"); strcpy(&h[234][0], "ea"); strcpy(&h[235][0], "eb"); strcpy(&h[236][0], "ec"); strcpy(&h[237][0], "ed"); strcpy(&h[238][0], "ee"); strcpy(&h[239][0], "ef");
    strcpy(&h[240][0], "f0"); strcpy(&h[241][0], "f1"); strcpy(&h[242][0], "f2"); strcpy(&h[243][0], "f3"); strcpy(&h[244][0], "f4"); strcpy(&h[245][0], "f5"); strcpy(&h[246][0], "f6"); strcpy(&h[247][0], "f7"); strcpy(&h[248][0], "f8"); strcpy(&h[249][0], "f9"); strcpy(&h[250][0], "fa"); strcpy(&h[251][0], "fb");
    strcpy(&h[252][0], "fc"); strcpy(&h[253][0], "fd"); strcpy(&h[254][0], "fe"); strcpy(&h[255][0], "ff");
}

void guide(bool comments) {
    using namespace std;

    ofstream file(VERSION_TEXT);
    if(comments) {
        file << "kopic FLTK Version " << VERSION << "\n" << endl 
            << "kopic         # Read kopic.xbm " << endl 
            << "kopic -c      # Produce kopic.csv from kopic.xbm " << endl 
            << "kopic -c -38- # Use From, not 38. " << endl 
            << "kopic -cd2    # Produce kopic.csv from kopic.xbm and decrement by 2. " << endl 
            << "kopic -e-     # Do not edit kopic.csv " << endl 
            << "kopic -f      # Produce full-swing kopic.txt from kopic.csv " << endl 
            << "kopic -g      # Use rannu.txt to weight balls. " << endl 
            << "kopic -k      # Produce kopic.kun from kopic.xbm " << endl 
            << "kopic -m      # Read many_one.txt " << endl 
            << "kopic -o30    # Output 30 lines. " << endl 
            << "kopic -pm     # MT " << endl 
            << "kopic -px     # xorshift " << endl 
            << "kopic -r-     # Do not remove temporary files. " << endl 
            << "kopic -s9-9   # Every cell is 9 pixels wide and 9 pixels high. " << endl 
            << "kopic -t      # Produce kopic.txt from kopic.xbm " << endl 
            << "kopic -y      # recovery " << endl 
            << "kopic -V      # version " << endl 
            << "kopic -VC     # version with comments " << endl 
            << "kopic -w-     # Do not weight balls. " << endl 
            << "kopic file_name.csv    # Read file_name.csv regardless of kopic.xbm " << endl 
            << "kopic file_name.kun    # Produce kopic.txt from file_name.kun " << endl 
            << "kopic file_name.txt    # Produce kopic.xbm from file_name.txt " << endl 
            << "kopic file_name.xbm    # Read file_name.xbm " << endl 
            << "kopic file_name.txt -n # Produce and read new kopic.xbm " << endl;
    } else {
        file << "kopic FLTK Version " << VERSION << "\n" << endl 
            << "kopic         " << endl 
            << "kopic -c      " << endl 
            << "kopic -c -38- " << endl 
            << "kopic -cd2    " << endl 
            << "kopic -e-     " << endl 
            << "kopic -f      " << endl 
            << "kopic -g      " << endl 
            << "kopic -k      " << endl 
            << "kopic -m      " << endl 
            << "kopic -o30    " << endl 
            << "kopic -pm     " << endl 
            << "kopic -px     " << endl 
            << "kopic -r-     " << endl 
            << "kopic -s9-9   " << endl 
            << "kopic -t      " << endl 
            << "kopic -y      " << endl 
            << "kopic -V      " << endl 
            << "kopic -VC     " << endl 
            << "kopic -w-     " << endl 
            << "kopic file_name.csv    " << endl 
            << "kopic file_name.kun    " << endl 
            << "kopic file_name.txt    " << endl 
            << "kopic file_name.xbm    " << endl 
            << "kopic file_name.txt -n " << endl;
    }

}

void Kun::counting(int data_width, int m) {
    check = true;
    black = 0;
    white = 0;

    for(int q = 0; q < data_width; q++) {
        if(check) {
            if(xbm_boolean_array[m][q] == check) {
                black += 1;
            } else {
                run_length[encoding_size] = black;
                encoding_size += 1;
                check = xbm_boolean_array[m][q];
                white = 1;
            }

        } else {
            if(xbm_boolean_array[m][q] == check) {
                white += 1;
            } else {
                run_length[encoding_size] = white;
                encoding_size += 1;
                check = xbm_boolean_array[m][q];
                black = 1;
            }

        }

    }

}

void Kun::manageText(int d) {
    decrement_by_n = d;
}

void Kun::mirrorImages(int data_width, int data_height) {
    int q, r;

    for(int m = 0; m < data_height; m++) {
        q = 0;
        for(int k = 0; k < data_width; k += ITEM_WIDTH) {
            r = k + ITEM_WIDTH - 1;
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r--] = xbm_boolean_array[m][q++];
            mirror_images[m][r] = xbm_boolean_array[m][q++];
        }

    }

}

void Kun::xbmBooleanArray(int data_width, int data_height) {
    int q;
    int n = 0; // data_bits[n]
    unsigned int b, s;
    unsigned char u;

    for(int m = 0; m < data_height; m++) {
        q = 0;
        for(int k = 0; k < data_width; k += ITEM_WIDTH, n++) {
            u = (unsigned char)data_bits[n];
            b = (int)u;

            for(int p = 0; p < ITEM_WIDTH; p++) {
                s = b & shift[p];
                if(s == shift[p]) {
                    xbm_boolean_array[m][q++] = true;
                } else {
                    xbm_boolean_array[m][q++] = false;
                }

            }

        }

    }

}
