#include "heightWidth.h"

extern MessagePane *messagePane;

void close_message_cb(Fl_Widget *, void *) {
    messagePane->hide();
}

void MessagePane::centering() {
    SITE_SIZE ss = measuringScreenSize(MESSAGE_WIDTH, MESSAGE_HEIGHT);
    messagePane->resize(ss.x, ss.y, ss.w, ss.h);
}

void MessagePane::helpHandler() {
    executeProgram(VIEW_PDF, "");
    hide();
}

#define button_data_width 32
#define button_data_height 32
static char button_data_bits[] = {
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0x0f,0x00,0x00,0xfc,0x0f,0x00,0x00,
0x0c,0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,
0x0c,0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,
0xfc,0x0f,0x00,0x00,0xfc,0x0f,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0xff,0x0f,0x00,0xfc,0xff,0x0f,0x00,
0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,
0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,
0xfc,0xff,0x0f,0x00,0xfc,0xff,0x0f,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xfc,0xff,0xff,0x0f,0xfc,0xff,0xff,0x0f,
0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,0x0c,
0x0c,0x00,0x00,0x0c,0x0c,0x00,0x00,0x0c,
0xfc,0xff,0xff,0x0f,0xfc,0xff,0xff,0x0f,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

bool MessagePane::setting(PICK_CODE *p) {
    using namespace std;

    const int BORDER_AREA = 20;
    const int BUTTON_X = 0;
    const int BUTTON_Y = 0;
    const int TEXT_AREA_HEIGHT = 40;

// Using a bitmap as the button label
    bitmapButton = new Fl_Button(BUTTON_X, BUTTON_Y, BITMAP_BUTTON_WIDTH, BITMAP_BUTTON_HEIGHT, "Help");
    bitmapButton->image( new Fl_Bitmap(button_data_bits, button_data_width, button_data_height) );
    bitmapButton->callback( (Fl_Callback *)help_cb, this);

// Close
    closeButton = new Fl_Button( MESSAGE_WIDTH - CLOSE_BUTTON_WIDTH, BUTTON_Y, CLOSE_BUTTON_WIDTH, CLOSE_BUTTON_HEIGHT, "Close");
    closeButton->callback( (Fl_Callback *)close_message_cb, this);

// Labeled text box
    Fl_Text_Buffer *buffer = new Fl_Text_Buffer();
    Fl_Text_Display *display = new Fl_Text_Display(BORDER_AREA, BITMAP_BUTTON_HEIGHT + BORDER_AREA, MESSAGE_WIDTH - 2 * BORDER_AREA, TEXT_AREA_HEIGHT + BORDER_AREA, "Kopic");
    display->buffer(buffer);
    display->textsize(22);
    display->box(FL_FLAT_BOX);

    stringstream os;
    os << p->temporary_file_name;
    string s = os.str();
    buffer->text( s.c_str() );

    bitmapButton->take_focus();
    return true;
}

