#include "rannuText.h"

extern MANAGE_MEMO *mm;

bool RandomNumber::createRannuText(std::string & pathName) {
    using namespace std;

    double difference, range;
    int k, plus;
    long bytes, e, size;
    string item;
    unsigned int g;

// C:\kopicFLTK\manage.txt for example
    NAMES a = driveDirectoryBase(pathName);
    string root = a.name[1];
    string directoryName = root + a.name[2]; // C:\kopicFLTK\ for example

    if(csv) {
        separator = COMMA;
        rannuText = RANNU_CSV;
    } else {
        separator = GAP;
        rannuText = RANNU_TXT;
    }

// Redirecting unless rannuText is opened.
    Feedable *f;
    if(produce_rannu_text) {
        pathName = directoryName + rannuText;
        mm->pathName = pathName;
        if(csv) {
            cout << pathName << endl;
        }

        if(lineCount == LARGE_NUMBER) {
            f = new FileOutputNewLine(pathName);
        } else {
            f = new FileOutputNewLineCount(pathName, lineCount);
        }

        if(! f->openRannuText() ) {
            return false;
        }

    } else {
        if(lineCount == LARGE_NUMBER) {
            f = new StandardOutputNewLine();
        } else {
            f = new StandardOutputNewLineCount(lineCount);
        }

    }

    f->setting(separator);

    if(seed == 0L) {
        e = (long)time(NULL);
        seed = e & SEED_MASK;
    }

    setPRNG();

    if(interval_1 == 63) {
        if(interval_0 == 0) {
            grouping = true;
            mm->grouping = grouping;
        }

    }

    if(grouping) {
// Buffering and grouping so that numbers can range from 0 to 63.
        const unsigned int MASK = B00000001;
        int boolStream[BOOL_STREAM_SIZE];
        unsigned int bits, u;
        unsigned int shift[6] = {
            B00000001,
            B00000010,
            B00000100,
            B00001000,
            B00010000,
            B00100000
        };

        k = 0;
        bytes = kilo * KB;
        size = 0L;
        while(size <= bytes) {
// Buffering
            u = random_integer();
            for(int i = 0; i < 32; ++i) {
                boolStream[k++] = MASK & u;
                u >>= 1;
            }

            if(k < BOOL_STREAM_SIZE) {
                continue;
            }

// Grouping
            for(k = 0; k < BOOL_STREAM_SIZE; ) {
                bits = 0;
                for(int i = 0; i < GROUP_SIZE; ++i) {
                    if(boolStream[k++]) {
                        bits |= shift[i];
                    }

                }

                item = b[bits];
                size = f->writing(item);
            }

            k = 0;
        }

    } else {
// Selecting an item and writing
        bytes = kilo * KB;
        difference = (double)( interval_1 - interval_0 + 1 );
        range = difference/4294967296.0;
        size = 0L;
        while(size <= bytes) {
            g = random_integer(); // 0 to 4294967295
            plus = (int) floor( range * (double)g );
            k = interval_0 + plus;
            item = b[k];
            size = f->writing(item);
        }

    }

    f->ending(csv);
    return true;
}

NAMES driveDirectoryBase(std::string & s) {
    using namespace std;

    const string EMPTY = "";
    const string SLASH = "/";
    const string YEN = "\\";
    int firstTrace, trace, w;
    int s_length = s.length();
    string c;

    NAMES part, undivided;
    part.name[0] = EMPTY; part.name[1] = EMPTY; part.name[2] = EMPTY; part.name[3] = EMPTY;
    undivided.name[0] = EMPTY; undivided.name[1] = EMPTY; undivided.name[2] = EMPTY; undivided.name[3] = EMPTY;

    part.name[0] = s; // s.length > 0; in other words, part.name[0].length > undivided.name[0].length

// s is divided into three parts: drive name, directory name, and base name.
    int k = 0;
    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == YEN) {
            part.separator = YEN;
            break;
        } else if(c == SLASH) {
            part.separator = SLASH;
            break;
        }

    }

    if(k == s_length) { // Neither YEN nor SLASH has been found.
        return undivided;
    } else {
        w = k + 1;
        part.name[1] = s.substr(0, w); // C:\ for example
        trace = ++k;
        firstTrace = trace;
    }

    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == part.separator) {
            trace = ++k;
        }

    }

    w = trace - firstTrace;
    part.name[2] = s.substr(firstTrace, w);
    part.name[3] = s.substr(trace); // manage.txt for example
    return part;
}

RandomNumber::RandomNumber(long k, long s, int f, int i0, int i1, int l, int p, bool c, bool g, bool pr): COMMA(","), GAP(" "), m00("00"), m01("01"), m02("02"), m03("03"), m04("04"), m05("05"), m06("06"), m07("07"), m08("08"), m09("09"), m10("10"), m11("11"), m12("12"), m13("13"), m14("14"), m15("15"), m16("16"), m17("17"), m18("18"), m19("19"), m20("20"), m21("21"), m22("22"), m23("23"), m24("24"), m25("25"), m26("26"), m27("27"), m28("28"), m29("29"), 
    m30("30"), m31("31"), m32("32"), m33("33"), m34("34"), m35("35"), m36("36"), m37("37"), m38("38"), m39("39"), m40("40"), m41("41"), m42("42"), m43("43"), m44("44"), m45("45"), m46("46"), m47("47"), m48("48"), m49("49"), m50("50"), m51("51"), m52("52"), m53("53"), m54("54"), m55("55"), m56("56"), m57("57"), m58("58"), m59("59"), 
    m60("60"), m61("61"), m62("62"), m63("63"), m64("64"), m65("65"), m66("66"), m67("67"), m68("68"), m69("69"), m70("70"), m71("71"), m72("72"), m73("73"), m74("74"), m75("75"), m76("76"), m77("77"), m78("78"), m79("79"), m80("80"), m81("81"), m82("82"), m83("83"), m84("84"), m85("85"), m86("86"), m87("87"), m88("88"), m89("89"), 
    m90("90"), m91("91"), m92("92"), m93("93"), m94("94"), m95("95"), m96("96"), m97("97"), m98("98"), m99("99"), RANNU_CSV("rannu.csv"), RANNU_TXT("rannu.txt") {

    b[0] = m00; b[1] = m01; b[2] = m02; b[3] = m03; b[4] = m04; b[5] = m05; b[6] = m06; b[7] = m07; b[8] = m08; b[9] = m09;
    b[10] = m10; b[11] = m11; b[12] = m12; b[13] = m13; b[14] = m14; b[15] = m15; b[16] = m16; b[17] = m17; b[18] = m18; b[19] = m19;
    b[20] = m20; b[21] = m21; b[22] = m22; b[23] = m23; b[24] = m24; b[25] = m25; b[26] = m26; b[27] = m27; b[28] = m28; b[29] = m29;
    b[30] = m30; b[31] = m31; b[32] = m32; b[33] = m33; b[34] = m34; b[35] = m35; b[36] = m36; b[37] = m37; b[38] = m38; b[39] = m39;
    b[40] = m40; b[41] = m41; b[42] = m42; b[43] = m43; b[44] = m44; b[45] = m45; b[46] = m46; b[47] = m47; b[48] = m48; b[49] = m49;
    b[50] = m50; b[51] = m51; b[52] = m52; b[53] = m53; b[54] = m54; b[55] = m55; b[56] = m56; b[57] = m57; b[58] = m58; b[59] = m59;
    b[60] = m60; b[61] = m61; b[62] = m62; b[63] = m63; b[64] = m64; b[65] = m65; b[66] = m66; b[67] = m67; b[68] = m68; b[69] = m69;
    b[70] = m70; b[71] = m71; b[72] = m72; b[73] = m73; b[74] = m74; b[75] = m75; b[76] = m76; b[77] = m77; b[78] = m78; b[79] = m79;
    b[80] = m80; b[81] = m81; b[82] = m82; b[83] = m83; b[84] = m84; b[85] = m85; b[86] = m86; b[87] = m87; b[88] = m88; b[89] = m89;
    b[90] = m90; b[91] = m91; b[92] = m92; b[93] = m93; b[94] = m94; b[95] = m95; b[96] = m96; b[97] = m97; b[98] = m98; b[99] = m99;

    csv = c;
    from = f;
    grouping = g;
    interval_0 = i0;
    interval_1 = i1;
    kilo = k;
    lineCount = l;
    prng = p;
    produce_rannu_text = pr;
    seed = s;

    prn = new MT(seed);
}

void RandomNumber::setPRNG() {
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;

    delete prn;
    switch (prng) {
    case MERSENNE_TWISTER:
        prn = new MT(seed);
        break;
    case XORSHIFT:
        prn = new Xorshift(seed);
        break;
    default:
        prng = MERSENNE_TWISTER;
        mm->prng = prng;
        prn = new MT(seed);
        break;
    }

// idling
    for(int k = 0; k < from; ++k) { 
        random_integer();
    }

}
