#include "heightWidth.h"

extern char *random_number;
extern Kopic *kopic;
extern long untouched;
extern MANAGE_MEMO *mm;
extern WeightPane *weightPane;

int WeightPane::centering() {
    SITE_SIZE ss = measuringScreenSize(WEIGHT_WIDTH, WEIGHT_HEIGHT);
    weightPane->resize(ss.x, ss.y, ss.w, ss.h);

    int BORDER_X = ::GetSystemMetrics(SM_CXFIXEDFRAME);
    int BORDER_Y = ::GetSystemMetrics(SM_CYFIXEDFRAME);
    int border = BORDER_X > BORDER_Y ? BORDER_X : BORDER_Y;
    return border;
}

PICK_CODE WeightPane::setting(const char *f, KUN_CODE *p) {
    using namespace std;

    const string RANNU_TXT(RANDOM_NUMBER_TEXT);
    const string YEN = "\\";
    string pathName = currentDirectory();
    pathName += YEN;
    pathName += RANNU_TXT;

    mm->csv = false;
    mm->grouping = p->grouping;
    mm->interval_0 = 1;
    mm->interval_1 = 37;
    mm->kilo = KILOBYTES;
    mm->lineCount = LARGE_NUMBER;
    mm->pathName = pathName;
    mm->prng = p->prng;
    mm->produce_rannu_text = true;

    bool check[100]; // 0 to 99
    bool csv = mm->csv;
    bool produce_rannu_text = mm->produce_rannu_text;
    bool rannu_text_required, wide_range;
    int b;
    int interval_0 = mm->interval_0;
    int interval_1 = mm->interval_1;
    int lineCount = mm->lineCount;
    int prng = mm->prng;
    long kilo = mm->kilo;
    long table_size = 1L;
    PICK_CODE pc;
    RandomNumber *rn;

    strcpy(pc.file_name, f);
    grouping = p->grouping;
    mapping = p->mapping;
    weight = p->weight;

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(pc.file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
    }

// Reading KOPIC_CSV
    Pickable *k;
    if(p->weight) {
        if(p->mapping) {
            k = new Mapping();
            rannu_text_required = true;
            wide_range = false;
        } else {
            if(p->grouping) {
                k = new Tint();
                rannu_text_required = true;
                wide_range = true;
            } else {
                k = new Weight();
                rannu_text_required = false;
                wide_range = false;
            }

        }

    } else {
        k = new Transparent();
        rannu_text_required = true;
        wide_range = false;
    }

    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int count = k->comboCount();
    int from = k->idling();
    long seed = (long)k->seedData();
    if(seed == 0L) {
        long e = (long)time(NULL);
        seed = e & SEED_MASK;
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();

//        int q = (int) rn->random_integer();
//        int repeat = k->repetition();
//        from += q%repeat;
    } else {
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();
    }

    mm->seed = seed;
    if(rannu_text_required) {
        ifstream test(RANDOM_NUMBER_TEXT);
        if( test.fail() ) {
            rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, p->grouping, produce_rannu_text);
            rn->createRannuText(mm->pathName);
        } else {
            test.close();
        }

// Reading RANNU_TEXT to produce a random-number array
        setTwoDigitNumbers(); // two_digit_number[][]
        readRannuText(&table_size); // random_number[u]
        k->randomNumberArray(table_size, from);
        if(wide_range) {
            k->wideRange();
        }

    } else {
// Because the function internally produces random numbers, an external random-number table is unnecessary.
        k->internallyProduce(rn); // Weight::function( )

        random_number = new char[MAIN_BUFFER_SIZE];
        memset(random_number, 0, MAIN_BUFFER_SIZE);
        table_size = (long)MAIN_BUFFER_SIZE;
    }

// text fields of the Weight pane
    field[0] = 0;
    for(int i = 1; i <= ALL; ++i) {
        field[i] = k->floor_weight(i);
    }

    field[38] = from;
    field[39] = 0;
    field[40] = from + count;
    field[41] = k->seedData();

    char buffer[VERY_SMALL_BUFFER_SIZE];
    const int BORDER = 3;
    const int BORDER_AREA = 73;
    const int BUTTON_X = WEIGHT_WIDTH - PICK_BUTTON_WIDTH - BORDER;
    const int FIELD_X = 2 * BORDER_AREA + FIELD_WIDTH;
    int y = 0;
    string kopicLogText = k->logFileName();

    pickButton = new Fl_Button(0, 0, PICK_BUTTON_WIDTH, PICK_BUTTON_HEIGHT, "Pick");
    pickButton->callback( (Fl_Callback *)log_cb, this);
    pickButton->take_focus();

    closeButton = new Fl_Button(BUTTON_X, y, CLOSE_BUTTON_WIDTH, CLOSE_BUTTON_HEIGHT, "Close");
    closeButton->callback( (Fl_Callback *)close_weight_cb, this);

    y += CLOSE_BUTTON_HEIGHT + BORDER;
    input1 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "01");
    figures(buffer, field[1]); input1->value(buffer);
    input1->box(FL_BORDER_BOX);
    input1->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input2 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "02");
    figures(buffer, field[2]); input2->value(buffer);
    input2->box(FL_BORDER_BOX);
    input2->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input3 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "03");
    figures(buffer, field[3]); input3->value(buffer);
    input3->box(FL_BORDER_BOX);
    input3->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input4 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "04");
    figures(buffer, field[4]); input4->value(buffer);
    input4->box(FL_BORDER_BOX);
    input4->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input5 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "05");
    figures(buffer, field[5]); input5->value(buffer);
    input5->box(FL_BORDER_BOX);
    input5->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input6 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "06");
    figures(buffer, field[6]); input6->value(buffer);
    input6->box(FL_BORDER_BOX);
    input6->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input7 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "07");
    figures(buffer, field[7]); input7->value(buffer);
    input7->box(FL_BORDER_BOX);
    input7->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input8 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "08");
    figures(buffer, field[8]); input8->value(buffer);
    input8->box(FL_BORDER_BOX);
    input8->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input9 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "09");
    figures(buffer, field[9]); input9->value(buffer);
    input9->box(FL_BORDER_BOX);
    input9->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input10 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "10");
    figures(buffer, field[10]); input10->value(buffer);
    input10->box(FL_BORDER_BOX);
    input10->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input11 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "11");
    figures(buffer, field[11]); input11->value(buffer);
    input11->box(FL_BORDER_BOX);
    input11->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input12 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "12");
    figures(buffer, field[12]); input12->value(buffer);
    input12->box(FL_BORDER_BOX);
    input12->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input13 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "13");
    figures(buffer, field[13]); input13->value(buffer);
    input13->box(FL_BORDER_BOX);
    input13->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input14 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "14");
    figures(buffer, field[14]); input14->value(buffer);
    input14->box(FL_BORDER_BOX);
    input14->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input15 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "15");
    figures(buffer, field[15]); input15->value(buffer);
    input15->box(FL_BORDER_BOX);
    input15->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input16 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "16");
    figures(buffer, field[16]); input16->value(buffer);
    input16->box(FL_BORDER_BOX);
    input16->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input17 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "17");
    figures(buffer, field[17]); input17->value(buffer);
    input17->box(FL_BORDER_BOX);
    input17->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input18 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "18");
    figures(buffer, field[18]); input18->value(buffer);
    input18->box(FL_BORDER_BOX);
    input18->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input19 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "19");
    figures(buffer, field[19]); input19->value(buffer);
    input19->box(FL_BORDER_BOX);
    input19->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input20 = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "20");
    figures(buffer, field[20]); input20->value(buffer);
    input20->box(FL_BORDER_BOX);
    input20->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    int x = BORDER_AREA - PRNG_BUTTON_WIDTH;
    xorshiftButton = new Fl_Button(x, y, PRNG_BUTTON_WIDTH, PRNG_BUTTON_HEIGHT, " xorshift");
    xorshiftButton->callback( (Fl_Callback *)PRNG_cb, this);
    xorshiftButton->box(FL_FLAT_BOX);
    xorshiftButton->hide();

    MTbutton = new Fl_Button(x, y, PRNG_BUTTON_WIDTH, PRNG_BUTTON_HEIGHT, "       MT");
    MTbutton->callback( (Fl_Callback *)PRNG_cb, this);
    MTbutton->box(FL_FLAT_BOX);
    MTbutton->hide();

    PRNGbutton = new Fl_Button(x, y, PRNG_BUTTON_WIDTH, PRNG_BUTTON_HEIGHT, "         ");
    PRNGbutton->callback( (Fl_Callback *)PRNG_cb, this);
    PRNGbutton->box(FL_FLAT_BOX);
    PRNGbutton->show();

    if(mapping) {
        indicator = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "");
        indicator->value(MAPPING_INDICATOR);
    } else {
        if(grouping) {
            indicator = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "");
            indicator->value(GROUPING_INDICATOR);
        } else {
            if(! weight) {
                indicator = new Fl_Input(BORDER_AREA, y, FIELD_WIDTH, FIELD_HEIGHT, "");
                indicator->value(TRANSPARENT_INDICATOR);
            }

        }

    }

    y = CLOSE_BUTTON_HEIGHT + BORDER;
    input21 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "21");
    figures(buffer, field[21]); input21->value(buffer);
    input21->box(FL_BORDER_BOX);
    input21->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input22 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "22");
    figures(buffer, field[22]); input22->value(buffer);
    input22->box(FL_BORDER_BOX);
    input22->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input23 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "23");
    figures(buffer, field[23]); input23->value(buffer);
    input23->box(FL_BORDER_BOX);
    input23->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input24 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "24");
    figures(buffer, field[24]); input24->value(buffer);
    input24->box(FL_BORDER_BOX);
    input24->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input25 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "25");
    figures(buffer, field[25]); input25->value(buffer);
    input25->box(FL_BORDER_BOX);
    input25->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input26 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "26");
    figures(buffer, field[26]); input26->value(buffer);
    input26->box(FL_BORDER_BOX);
    input26->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input27 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "27");
    figures(buffer, field[27]); input27->value(buffer);
    input27->box(FL_BORDER_BOX);
    input27->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input28 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "28");
    figures(buffer, field[28]); input28->value(buffer);
    input28->box(FL_BORDER_BOX);
    input28->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input29 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "29");
    figures(buffer, field[29]); input29->value(buffer);
    input29->box(FL_BORDER_BOX);
    input29->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input30 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "30");
    figures(buffer, field[30]); input30->value(buffer);
    input30->box(FL_BORDER_BOX);
    input30->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input31 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "31");
    figures(buffer, field[31]); input31->value(buffer);
    input31->box(FL_BORDER_BOX);
    input31->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input32 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "32");
    figures(buffer, field[32]); input32->value(buffer);
    input32->box(FL_BORDER_BOX);
    input32->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input33 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "33");
    figures(buffer, field[33]); input33->value(buffer);
    input33->box(FL_BORDER_BOX);
    input33->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input34 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "34");
    figures(buffer, field[34]); input34->value(buffer);
    input34->box(FL_BORDER_BOX);
    input34->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input35 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "35");
    figures(buffer, field[35]); input35->value(buffer);
    input35->box(FL_BORDER_BOX);
    input35->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input36 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "36");
    figures(buffer, field[36]); input36->value(buffer);
    input36->box(FL_BORDER_BOX);
    input36->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input37 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "37");
    figures(buffer, field[37]); input37->value(buffer);
    input37->box(FL_BORDER_BOX);
    input37->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input38 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "From");
    figures(buffer, field[38]); input38->value(buffer);
    input38->box(FL_BORDER_BOX);
    input38->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input39 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "Log");
    input39->value( kopicLogText.c_str() );
    input39->box(FL_BORDER_BOX);
    input39->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input40 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "Repeat");
    figures(buffer, field[40]); input40->value(buffer);
    input40->box(FL_BORDER_BOX);
    input40->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    y += FIELD_HEIGHT + BORDER;
    input41 = new Fl_Input(FIELD_X, y, FIELD_WIDTH, FIELD_HEIGHT, "Setting");
    figures(buffer, field[41]); input41->value(buffer);
    input41->box(FL_BORDER_BOX);
    input41->when( FL_WHEN_ENTER_KEY | FL_WHEN_NOT_CHANGED );

    delete k;
    delete rn;
    pc.code = UNPICKED;
    return pc;
}

void close_weight_cb(Fl_Widget *, void *) {
    weightPane->hide();
}

PICK_CODE WeightPane::textFields() {
    using namespace std;

    char buffer[VERY_SMALL_BUFFER_SIZE];
    int f;
    PICK_CODE pc;

// Reading KOPIC_CSV
    Pickable *k;
    k = new Weight();
    k->variables();
    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int from = k->idling();
    string kopicLogText = k->logFileName();

// text fields of the Weight pane
    field[0] = 0;
    for(int i = 1; i <= ALL; ++i) {
        field[i] = k->floor_weight(i);
    }

    field[38] = from;
    field[39] = 0;
    field[40] = k->repetition();
    field[41] = k->seedData();

    figures(buffer, field[1]); input1->value(buffer);
    figures(buffer, field[2]); input2->value(buffer);
    figures(buffer, field[3]); input3->value(buffer);
    figures(buffer, field[4]); input4->value(buffer);
    figures(buffer, field[5]); input5->value(buffer);
    figures(buffer, field[6]); input6->value(buffer);
    figures(buffer, field[7]); input7->value(buffer);
    figures(buffer, field[8]); input8->value(buffer);
    figures(buffer, field[9]); input9->value(buffer);
    figures(buffer, field[10]); input10->value(buffer);
    figures(buffer, field[11]); input11->value(buffer);
    figures(buffer, field[12]); input12->value(buffer);
    figures(buffer, field[13]); input13->value(buffer);
    figures(buffer, field[14]); input14->value(buffer);
    figures(buffer, field[15]); input15->value(buffer);
    figures(buffer, field[16]); input16->value(buffer);
    figures(buffer, field[17]); input17->value(buffer);
    figures(buffer, field[18]); input18->value(buffer);
    figures(buffer, field[19]); input19->value(buffer);
    figures(buffer, field[20]); input20->value(buffer);
    figures(buffer, field[21]); input21->value(buffer);
    figures(buffer, field[22]); input22->value(buffer);
    figures(buffer, field[23]); input23->value(buffer);
    figures(buffer, field[24]); input24->value(buffer);
    figures(buffer, field[25]); input25->value(buffer);
    figures(buffer, field[26]); input26->value(buffer);
    figures(buffer, field[27]); input27->value(buffer);
    figures(buffer, field[28]); input28->value(buffer);
    figures(buffer, field[29]); input29->value(buffer);
    figures(buffer, field[30]); input30->value(buffer);
    figures(buffer, field[31]); input31->value(buffer);
    figures(buffer, field[32]); input32->value(buffer);
    figures(buffer, field[33]); input33->value(buffer);
    figures(buffer, field[34]); input34->value(buffer);
    figures(buffer, field[35]); input35->value(buffer);
    figures(buffer, field[36]); input36->value(buffer);
    figures(buffer, field[37]); input37->value(buffer);
    figures(buffer, field[38]); input38->value(buffer);
    input39->value( kopicLogText.c_str() );
    figures(buffer, field[40]); input40->value(buffer);
    figures(buffer, field[41]); input41->value(buffer);
    delete k;
    pc.code = UNPICKED;
    return pc;
}

void figures(char *buffer, int value) {
    using namespace std;

    stringstream os;
    os << value;
    string s = os.str();
    strcpy(buffer, s.c_str() );
}

void log_cb(Fl_Widget *, void *) {
    weightPane->logHandler();
}

void PRNG_cb(Fl_Widget *, void *) {
    weightPane->PRNGhandler();
}

void WeightPane::logHandler() {
    using namespace std;

    char *stop;
    const int DECIMAL = 10;
    int f;
    f = (int)strtol( input1->value(), &stop, DECIMAL); field[1] = f >= 0 ? f : 0;
    f = (int)strtol( input2->value(), &stop, DECIMAL); field[2] = f >= 0 ? f : 0;
    f = (int)strtol( input3->value(), &stop, DECIMAL); field[3] = f >= 0 ? f : 0;
    f = (int)strtol( input4->value(), &stop, DECIMAL); field[4] = f >= 0 ? f : 0;
    f = (int)strtol( input5->value(), &stop, DECIMAL); field[5] = f >= 0 ? f : 0;
    f = (int)strtol( input6->value(), &stop, DECIMAL); field[6] = f >= 0 ? f : 0;
    f = (int)strtol( input7->value(), &stop, DECIMAL); field[7] = f >= 0 ? f : 0;
    f = (int)strtol( input8->value(), &stop, DECIMAL); field[8] = f >= 0 ? f : 0;
    f = (int)strtol( input9->value(), &stop, DECIMAL); field[9] = f >= 0 ? f : 0;
    f = (int)strtol( input10->value(), &stop, DECIMAL); field[10] = f >= 0 ? f : 0;
    f = (int)strtol( input11->value(), &stop, DECIMAL); field[11] = f >= 0 ? f : 0;
    f = (int)strtol( input12->value(), &stop, DECIMAL); field[12] = f >= 0 ? f : 0;
    f = (int)strtol( input13->value(), &stop, DECIMAL); field[13] = f >= 0 ? f : 0;
    f = (int)strtol( input14->value(), &stop, DECIMAL); field[14] = f >= 0 ? f : 0;
    f = (int)strtol( input15->value(), &stop, DECIMAL); field[15] = f >= 0 ? f : 0;
    f = (int)strtol( input16->value(), &stop, DECIMAL); field[16] = f >= 0 ? f : 0;
    f = (int)strtol( input17->value(), &stop, DECIMAL); field[17] = f >= 0 ? f : 0;
    f = (int)strtol( input18->value(), &stop, DECIMAL); field[18] = f >= 0 ? f : 0;
    f = (int)strtol( input19->value(), &stop, DECIMAL); field[19] = f >= 0 ? f : 0;
    f = (int)strtol( input20->value(), &stop, DECIMAL); field[20] = f >= 0 ? f : 0;
    f = (int)strtol( input21->value(), &stop, DECIMAL); field[21] = f >= 0 ? f : 0;
    f = (int)strtol( input22->value(), &stop, DECIMAL); field[22] = f >= 0 ? f : 0;
    f = (int)strtol( input23->value(), &stop, DECIMAL); field[23] = f >= 0 ? f : 0;
    f = (int)strtol( input24->value(), &stop, DECIMAL); field[24] = f >= 0 ? f : 0;
    f = (int)strtol( input25->value(), &stop, DECIMAL); field[25] = f >= 0 ? f : 0;
    f = (int)strtol( input26->value(), &stop, DECIMAL); field[26] = f >= 0 ? f : 0;
    f = (int)strtol( input27->value(), &stop, DECIMAL); field[27] = f >= 0 ? f : 0;
    f = (int)strtol( input28->value(), &stop, DECIMAL); field[28] = f >= 0 ? f : 0;
    f = (int)strtol( input29->value(), &stop, DECIMAL); field[29] = f >= 0 ? f : 0;
    f = (int)strtol( input30->value(), &stop, DECIMAL); field[30] = f >= 0 ? f : 0;
    f = (int)strtol( input31->value(), &stop, DECIMAL); field[31] = f >= 0 ? f : 0;
    f = (int)strtol( input32->value(), &stop, DECIMAL); field[32] = f >= 0 ? f : 0;
    f = (int)strtol( input33->value(), &stop, DECIMAL); field[33] = f >= 0 ? f : 0;
    f = (int)strtol( input34->value(), &stop, DECIMAL); field[34] = f >= 0 ? f : 0;
    f = (int)strtol( input35->value(), &stop, DECIMAL); field[35] = f >= 0 ? f : 0;
    f = (int)strtol( input36->value(), &stop, DECIMAL); field[36] = f >= 0 ? f : 0;
    f = (int)strtol( input37->value(), &stop, DECIMAL); field[37] = f >= 0 ? f : 0;
    f = (int)strtol( input38->value(), &stop, DECIMAL); field[38] = f >= 0 ? f : 400;
    field[39] = 0;
    f = (int)strtol( input40->value(), &stop, DECIMAL); field[40] = f >= 0 ? f : 420;
    f = (int)strtol( input41->value(), &stop, DECIMAL); field[41] = f >= 0 ? f : 123456;

    ofstream csv_file(KOPIC_CSV);
    if( csv_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream csv_file(KOPIC_CSV)" << endl;
        return;
    }

    string b01("01,"); string b02("02,"); string b03("03,"); string b04("04,"); string b05("05,"); string b06("06,"); string b07("07,"); string b08("08,"); string b09("09,"); string b10("10,");
    string b11("11,"); string b12("12,"); string b13("13,"); string b14("14,"); string b15("15,"); string b16("16,"); string b17("17,"); string b18("18,"); string b19("19,"); string b20("20,");
    string b21("21,"); string b22("22,"); string b23("23,"); string b24("24,"); string b25("25,"); string b26("26,"); string b27("27,"); string b28("28,"); string b29("29,"); string b30("30,");
    string b31("31,"); string b32("32,"); string b33("33,"); string b34("34,"); string b35("35,"); string b36("36,"); string b37("37,");
    string EMPTY("");

    string d[ ALL + 1 ];
    d[0] = EMPTY;
    d[1] = b01; d[2] = b02; d[3] = b03; d[4] = b04; d[5] = b05; d[6] = b06; d[7] = b07; d[8] = b08; d[9] = b09; d[10] = b10;
    d[11] = b11; d[12] = b12; d[13] = b13; d[14] = b14; d[15] = b15; d[16] = b16; d[17] = b17; d[18] = b18; d[19] = b19; d[20] = b20;
    d[21] = b21; d[22] = b22; d[23] = b23; d[24] = b24; d[25] = b25; d[26] = b26; d[27] = b27; d[28] = b28; d[29] = b29; d[30] = b30;
    d[31] = b31; d[32] = b32; d[33] = b33; d[34] = b34; d[35] = b35; d[36] = b36; d[37] = b37;

    for(int line = 1; line <= ALL; line += 1 ) {
        csv_file << d[line] << field[line] << endl;
    }

    csv_file << "From," << field[FROM_LINE] << endl 
        << "Log," << input39->value() << endl
        << "Repeat," << field[REPEAT_LINE] << endl 
        << "Setting," << field[SETTING_LINE] << endl;

    csv_file.close();
    untouched = modified_file(KOPIC_CSV);

    KUN_CODE kc;
    kc.defectiveCsv = false;
    kc.full_swing = false;
    kc.grouping = grouping;
    kc.mapping = mapping;
    kc.weight = weight;
    PICK_CODE pc = kopicLog(KOPIC_CSV, &kc);
    kopic->temporaryFileName(pc.temporary_file_name);
}

void WeightPane::PRNGhandler() {
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;

    MTbutton->hide();
    PRNGbutton->hide();
    xorshiftButton->hide();

    session += 1;
    int phase = session%3; // 0, 1, 2

    switch (phase) {
    case 0:
        MTbutton->show();
        mm->prng = MERSENNE_TWISTER;
        break;
    case 1:
        xorshiftButton->show();
        mm->prng = XORSHIFT;
        break;
    default:
        PRNGbutton->show();
        mm->prng = MERSENNE_TWISTER;
        break;
    }

}

WeightPane::WeightPane(int W, int H, const char *t) : Fl_Double_Window(W, H, t), BUTTON_X(61), FIELD_HEIGHT(27), FIELD_WIDTH(65) {
    session = 0;
}

